
/****************************************************************************/
/*      TMK for Windows 95. ELCUS, 1995,2003.                               */
/****************************************************************************/

//#define STEND

#define TMK_CONFIGURATION_TABLE

#include <conio.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <errno.h>
#include <process.h>
#include <stdlib.h>

#include <windows.h>
#include "tmkinit.c"

#define CR 0x0D                 /*  ⪨ */
#define LF 0x0A
#define CTRL_C 0x03
#define ESCAPE 0x1B
#define BACKSPACE 0x08
#define TAB 0x09
                                /* ७  ASCII */
#define F01 0x3B00
#define F02 0x3C00
#define F03 0x3D00
#define F04 0x3E00
#define F05 0x3F00
#define F06 0x4000
#define F07 0x4100
#define F08 0x4200
#define F09 0x4300
#define F10 0x4400
#define PGUP 0x4900
#define PGDN 0x5100
#define HOME 0x4700
#define END 0x4F00
#define LEFT 0x4B00
#define RIGHT 0x4D00
#define UP 0x4800
#define DOWN 0x5000
#define GPLUSW 0x4E2B
#define GPLUS 0x4E00

#define BC_BUF_SIZE 64                 /* ࠧ  */
#define BC_DUMP_SIZE 36                 /* ⢮ 뢮   ᫮ */
#define CC_SIZE 4                       /* ⢮ ⮢   ࠢ */
#define TIME_OUT 0x0300                 /* ६  뢠   */

#define DUMP_WIDE 10                    /* ⢮ ᫮  ப */

#define RT_BUF_SIZE 32                  /* ࠧ  */
#define RT_DUMP_SIZE 32                 /* ⢮ 뢮   ᫮ */
#define SW_SIZE 5                       /* ⢮ ⮢  ⢥⭮ ᫮ */
#define ZONE_MASK 0x0020    /* ᪠  ࠡ  ⮬ ਥ/। */
#define RT_MASK 0x0080      /* ᪠ ⠭ ०  */

/* 騥 㭪樨 */
#ifdef STEND
unsigned short lpt_data_port, lpt_status_port, lpt_ctrl_port;
int lpt_num = 1;                         /*  ᯮ㥬 LPT */
void init_lpt();                         /* । ᮢ ⮢ */
void set_lpt_data(unsigned short char data);   /* 뢮    LPT */
#endif
void in_cmd(char *str);                  /* ਥ  ப */
int in_key();                            /*  ᨬ  ஢મ 뢠 */
void check_int();                        /* 㦥 뢠  饭 */
void make_func(unsigned short key);      /* ࠡ⪠ 㭪樮  */
void make_ctrl(int key);                 /* ࠡ⪠ ࠢ  */
void make_cmd(char *str);                /* ࠡ⪠  ப */
void make_quit();                        /* প 室  ⫠稪 */
void select_win(char *str);              /* 롮  */
void select_tmk(char *str);              /* 롮    */
void mode_bc(char *str);                 /* ⠭ ०  */
void mode_rt(char *str);                 /* ⠭ ०  */
//void mode_mt(char *str);               /* ⠭ ०  */
void select_tmk(char *str);              /* 롮    */
void comment(char *str);                 /* 뢮  */
void kbd_pause(char *str);               /* ணࠬ㥬 㧠 */
void fields_chg(char *str);              /* ࠢ 뤥  */
// void prtscr_brk();                      /* ࠡ稪 뢠 PrtScr */
void cmds_open(char *str);               /* ⨥  䠩 */
void cmds_open2(char *str);              /* 믮  䠩   横 */
void cmd_reset(char *str);               /*  ஫ */
void buf_fill(char *str);                /*   ⠭⮩ */
void buf_clear(char *str);               /* ⪠  */
void buf_edit(char *str);                /* ।஢ ୮  */
int mark_set(char *str, int *mark);       /*  ⥪饣 ᫮  ।஢ */
int end_ctrl(char *str);                 /* ஫  ப */
void msg_out(char *msg);                 /* 뢮 ப ᮮ饭 */
void all_screen();                       /* 뢮 ᥣ ࠭ */
void out_func_str();                     /* 祭 㭪樮  */
void out_mode();                         /* 뢮 ० ࠡ */
void set_io_delay(char *str);
void out_port(unsigned short wPort);     /* 뢮   */
void out_irq(unsigned short wIrq);       /* 뢮  뢠  */
void out_type();                         /* 뢮 ⨯  */
void out_fname();                        /* 뢮  ᫥ 䠩  */
void out_inn();                          /* 뢮  뢠 */
void out_buffer();                       /* 뢮   */
void bin_unpack(int x, int y, int adr, int data);/* 筠 ࠧ⪠ */
void out_dump(unsigned short *data);           /* 뢮  */
void out_bin(int data, int num_digits);   /* 뢮  筮 ଥ */
void select_window(int nwin);
void set_stat_len(char *str);            /*  横  ⨪
                                             ⮬᪨  */
void CheckTmkEvent(int fWaitEvent);

/* 㭪樨   */
void bc_help(char *str);                 /* 뢮 ᪠ */
void bc_clear_ram();                     /* 㫥   */
int bc_ram_test(char *str);              /* ஢   */
void bc_buf_rd(char *str);               /* ⥭    䠩 */
void bc_buf_wr(char *str);               /*    䠩 */
void sym(char *str);                     /* ᨬ஢ */
void statistic_out(char *str);           /* 뢮 ⨪  */
void statistic_bad_out(char *str);       /* 뢮 ⨪ ᡮ  */
void statistic_clear(char *str);         /* ⪠ ६ ⨪ */
int start_loop(char *str);               /*   横 */
int start_loop_n(unsigned long counter); /*   横 */
int start_1(char *str);                  /*   */
int start();                             /*  */
void set_base(char *str);                /* ⠭  */
void set_count(char *str);               /* ⠭ 横 ७  */
void set_pause(char *str);               /* ⠭  */
void set_ctrl_code(char *str);           /*  ⠭  ࠢ */
void set_number(char *str);              /*  ⠭   */
void out_number();                       /* 뢮   */
void out_base();                         /* 뢮  */
void out_count();                        /* 뢮 祭 稪 ७ */
void out_pause();                        /* 뢮 祭  */
void out_ctrl_code();                    /* 뢮  ࠢ */
void bc_out_sw();                        /* 뢮 ॣ ᫮ ﭨ */
void bc_out_ram(TMK_DATA base);               /* 뢮  ࠭  */
int correct_cc(int ctrl_code);           /* ஢ઠ ४⭮ .  */

/* 㭪樨   */
void block_data_irq(char *str);          /* ஢ 뢠  */
void unblock_data_irq(char *str);        /* ࠧ஢ 뢠  */
void rt_clear_ram();                     /* 㫥   */
int rt_ram_test(char *str);              /* ஢   */
void rt_help(char *str);                 /* 뢮 ᪠ */
void rt_buf_rd(char *str);               /* ⥭    䠩 */
void rt_buf_wr(char *str);               /*    䠩 */
void set_flag(char *str);                /* ⠭ 䫠 */
void rd_sw_loop(char *str);              /* ⥭ ᫮ ﭨ  横 */
void wr_mr_loop(char *str);              /* 横᪠    */
int set_subadr(char *str);               /*   */
void set_spage(char *str);               /* ⠭ ⥪饩 ࠭  */
void set_cpage(char *str);               /* ⠭ ⥪饩 ࠭  */
void set_page(char *str);                /* ⠭ ⥪饩 ࠭ */
void set_at(char *str);                  /* ⠭  ନ */
int wr_at(TMK_DATA at);                       /*   ନ   */
void set_subadr_r(char *str);            /* ⠭ ,  ਥ */
void set_subadr_t(char *str);            /* ⠭ ,  ਥ */
void set_status_word(char *str);         /*  ⠭ ⢥⭮ ᫮ () */
void set_sw_bits(char *str, TMK_DATA mask);    /* 㭪樨 ⠭ ⤥ ⮢  */
void read_sw(char *str);                 /* ⥭ ᫮ ﭨ */
void clear_sw_bits(char *str, TMK_DATA mask);  /* 㭪樨 ⪨ ⤥ ⮢  */
void wr_status_word();                   /*  ⮢  */
void out_rt_mode();
void out_page();                         /* 뢮  ࠭  */
void out_subadr();                       /* 뢮  */
void out_at();                           /* 뢮  ନ */
void out_status_word();                  /* 뢮 ⮢  */
void rt_out_sw();                        /* 뢮 ᫮ ﭨ */
void rt_out_ram(TMK_DATA dir, TMK_DATA subadr);     /* 뢮    */

const BC_DUMP_STRINGS=BC_DUMP_SIZE/DUMP_WIDE+1;
const RT_DUMP_STRINGS=RT_DUMP_SIZE/DUMP_WIDE+1;
const BDUMP_X=10, BDUMP_Y=6;
int DUMP_STRINGS;
int DUMP_SIZE;

char cmd_str[80];               /*    */
char old_cmd[80];               /*  ன  ப */
char ex_fname[80];              /*  横᪨ 믮塞 . 䠩 */
long cmd_count=1;               /* 稪 ७  */
long cur_count;                 /* ⥪騩 稪 横 ७ */
int str_ptr=0;                  /* 㪠⥫     ᮫ */

volatile unsigned short bc_sw=0xFFFF; /* ᫮ ﭨ  */
volatile unsigned short bc_aw1=0xFFFF;/* ࢮ ⢥⭮ ᫮, ᫨ bc_sw != 0 */
volatile unsigned short bc_aw2=0xFFFF;/* ஥ ⢥⭮ ᫮, ᫨ bc_sw != 0 */
TMK_DATA base;                       /*    */
TMK_DATA bus_num;                    /*   */
unsigned short ctrl_code=0x0;         /*  ࠢ */
unsigned short opause=0;              /* । ६  ⠬   */
unsigned short pause=0;         /* । ६  ⠬  ਮ
                                   ⠩ */

volatile int prtscr_flag=0;     /* 䫠  PrtScr */
volatile int int_num[MAX_TMK_NUMBER+1]; /*  뢠 */
                                /* ६ ⨪: */
#define BADLEN 100
volatile unsigned short bad_sws[BADLEN];
volatile unsigned short bad_aws[BADLEN];
volatile unsigned long bad_sts[BADLEN];
volatile unsigned long good_starts=0;/* ⢮ ଠ */
volatile unsigned long bad_starts=0; /*  ਩ 襭   , */
unsigned long to_errors=0;           /* ⮢  訢 뢠 */
unsigned long data_err=0;
unsigned long channel_err=0;
int fAAAA=1;

unsigned short buffer[64];            /*   */
unsigned short vbuffer[64];           /* ⥫  */
int buf_adr=0;                  /*    */
int buf_mark=0;                 /*  ᫮   뢮  BIN */
int in_ed_word=3;               /* । ⥪ ࠤ  ।஢ */
int buf_size;                   /* ⥪騩 ࠧ  */
int fields=1;                   /* ० 뢮  ࠢ饣 ᫮
                                   1 -  뢮, 0 -  */

volatile unsigned short rt_sw=0xFFFF;/* ᫮ ﭨ */
volatile unsigned short rt_cmd=0;    /*   */
int fLock=0;
TMK_DATA dir;                       /* ࠢ ।  */
TMK_DATA subadr;                    /*    */
TMK_DATA terminal_adr;              /*     */
TMK_DATA bram_page;                 /* ⥪ ࠭   ஭  */
TMK_DATA cram_page;                 /* ⥪ ࠭   ஭  */

HANDLE hIn, hOut;

int nMaxTMK;
int fInitBad = 0;

#define WAIT_EVENT 1
#define NO_WAIT_EVENT 0
int fGlobalWaitEvent = WAIT_EVENT;

SECURITY_ATTRIBUTES sa4Event;
//HANDLE hvxd;
HANDLE hEvent[MAX_TMK_NUMBER+1], hStartEvent, hBcEvent, ahWaitEvents[MAX_TMK_NUMBER+2];
int anWaitTmks[MAX_TMK_NUMBER+1];
int nWaitEvents;

/*
int aTmkLock[MAX_TMK_NUMBER+1];
int aRtArbLock[MAX_TMK_NUMBER+1];
int aRtAnswLock[MAX_TMK_NUMBER+1];
*/

/*
#define WAIT_PROXY 1
#define NO_WAIT_PROXY 0

pid_t aTmkProxy[MAX_TMK_NUMBER+1];
pid_t aProxy[MAX_TMK_NUMBER+1];
int aProxyTmkNum[MAX_TMK_NUMBER+1];

int nProxies = 0;

TTmkProxyData TmkProxyData;
*/

int nwin;                      /* ⥪饥 뢮  */
int nmainwin = 0;              /* ⥪饥 ࠡ祥  */
/*const int nMaxWin = 1;*/
#define nMaxWin 1
int fInt = 0;
char chLU, chRU, chLD, chRD, chH, chV;

struct TW
{
 int nX;
 int nY;
 int nDX;
 int nDY;
 int nTMK;
 int nType;
 int nMode;
 int fVisible;
 int at_avail;
 char data_fname[13];
};

struct TW Window[nMaxWin+1] = { { 1, 1, 80, 11, 0, -1, UNDEFINED_MODE, 0, 0, "" }, 
                         { 1, 12, 80, 11, 0, -1, UNDEFINED_MODE, 0, 0, "" } };

// void (*oldvect3)();/* ஥ 祭  PrtScr */

FILE *in_file;                  /* 䠩     */
FILE *out_file;                 /* 䠩 뢮    */
FILE *cmd_file;                 /* 䠩   */

char buf_str[100];              /*   ࠡ  䠩  */
int fSkipCmds=0;                /* 䫠 . 믮  䠩 */
int enter_mode=0;               /* ०  : 0 -  ᮫, 
                                                       1 -  䠩 */
                                /* ⠡ ४⭮ .  (1) */
char ccs[16]={1, 1, 1, 1, 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 0};
                                /* 㪠⥫  ᮮ饭  訡 */
char *inp_err="訡 ";
char *base_err="୮ 祭 ";
char *bus_num_err="ࠢ  ";
char *bad_ctrl_code="訡   ࠢ";
char *cc_no_def=" ࠢ XXXX  ।";
char *mark_err="४  ᫮";
char *undef_cmd="  ";
char *const_err="୮ 祭 ⠭";
char *cr_err="訡 ᮧ 䠩";
char *open_err="訡  䠩";
char *format_err="訡 ଠ 室 䠩";
char *bc_reset_ok=" ஫ ";
char *rt_reset_ok=" 筮 ன⢠";
char *subadr_err="୮ 祭 ";
char *bad_status_word="訡  ⢥⭮ ᫮";
char *no_int="室  ⠩-";
char *int_ok="뢠";
char *kbd_break=" ࢠ";

#define TIMER_CTRL_PORT 0x43       /*  ࠢ ⠩஬ */
#define TIMER0_PORT 0x40           /*   ⠩ 0 */
#define _30_MCSEC 36               /* প 30  */
#define _660_MCSEC 790             /* প 660  */
#define _5000_MCSEC 5966           /* প 5  */
#define TEST_RTFL 1
#define TEST_MASK_RTFL 2
#define TEST_UNMASK_RTFL 3
#define TEST_SSFL 4
#define TEST_BUSY 5
#define TEST_SREQ 6
#define TEST_DNBA_OFF 7
#define TEST_DNBA_ON 8
#define TEST_RESET 9
#define TEST_SYNC 10
#define TEST_GET_VECTOR 11
#define TEST_GET_SELFTEST 12
#define TEST_SYNC_DATA 13
#define TEST_AT 14
#define TEST_BUSY1 15
#define TEST_NOBUSY1 16
#define TEST_COUNTER 17
#define TEST_RT_RT_BRCST 18
#define TEST_COUNTER_RT_BC 19
#define TEST_COUNTER_BC_RT 20
#define TEST_DNBA 21
#define TEST_BRCST_CMD 22
#define TEST_BRCST_BIT 23
#define TEST_ERROR 24
#define TEST_SYNC_DATA1 25
#define TEST_SYNC_DATA_BRCST 26
#define TEST_NO_RT_15 27
#define TEST_RT_15 28
#define TEST_NO_RT_0A 29
#define TEST_RT_0A 30
#define TEST_OTHER_AT 31
#define TEST_BLOCK_TR 32
#define TEST_UNBLOCK_TR 33
#define TEST_BLOCKED_TR 34
#define TEST_UNBLOCKED_TR 35
#define TEST_RT_DATA_IRQ 36
#define TEST_RT_DATA_IRQ_BL 37

#define DNB 0x400                  /* ᪮ ࠢ */
#define SYNC 0x401                 /* ஭ */
#define GET_SW 0x402               /* । ⢥⭮ ᫮ */
#define START_SELFTEST 0x403       /*  ᠬ஫ */
#define BLOCK_TRANSMIT 0x404       /* ஢ ।稪 */
#define UNBLOCK_TRANSMIT 0x405     /* ஢ ।稪 */
#define MASK_RTFL 0x406            /*   䫠 ନ */
#define UNMASK_RTFL 0x407          /* ⬥   䫠 ନ */
#define RESET 0x408                /* ⠭ 室 ﭨ  */
#define GET_VECTOR 0x410           /* । ୮ ᫮ */
#define SYNC_DATA 0x011            /* ஭   */
#define GET_CMD 0x412              /* । ᫥  ᫮ */
#define GET_SELFTEST 0x413         /* । ᫮ ஥ ஫ */
#define BLOCK_SEL_TRANSMIT 0x04    /* ஢ ࠭ ।稪 */
#define UNBLOCK_SEL_TRANSMIT 0x015 /* ஢ ࠭ ।稪 */

int statistic_bc_rt(TMK_DATA st_base, TMK_DATA st_subadr, TMK_DATA st_data);
int statistic_rt_bc(TMK_DATA st_subadr, TMK_DATA st_base, TMK_DATA st_data);
void avt_bc(char *str);         /* প ஢ન  */
void avt_rt(char *str);         /* প ஢ન  */
void avt_ctrl(char *str);       /* ࠢ 뢮  ࠭ */
int cmp_ram_buf(int offset, int voffset, int size);

char *err_msg;
int bcwin, rtwin;
int bcnum, rtnum;
TMK_DATA rtadr, rtadr1, rtadr2;
unsigned short ci_field;
int hb_mode = 1;
TMK_DATA subadr1, subadr2, subadr0, dir0, len;
int avt_out = 1;
int avt_ok;
int fReserv = 0;
unsigned short nMainBus = BUS_A, nReservBus = BUS_B;

  long GL_COUNTER = 500;                      /* 稪 ⮢ */
  long GL_COUNTER2 = 1000; /*GL_COUNTER * 2;         /* 稪 ⮢ 2 */
  long GL_COUNTER3 = 2000; /*GL_COUNTER * 4;         /* 稪 ⮢ 3 */

int avtomat=0;                  /* 䫠 ࠡ  ⮬᪮ ०:
                                0 - 몫祭, 1 - 祭 */

unsigned long err_level=10;     /* ⢮ ।쭮 ⨬ 訡 */

DWORD biostime1;
//struct timespec biostime1;

int WinXMin = 0x20, 
    WinXMax = 0x20 + 79, 
    WinYMin = 0x20, 
    WinYMax = 0x20 + 24;
int WinXSav, WinYSav;
int ForeColor = 7, BackColor = 0, ForeIntens = 0;

#define BLACK 0
#define BLUE 1
#define GREEN 2
#define CYAN 3
#define RED 4
#define MAGENTA 5
#define BROWN 6
#define LIGHTGRAY 7
#define DARKGRAY 8
#define LIGHTBLUE 9
#define LIGHTGREEN 10
#define LIGHTCYAN 11
#define LIGHTRED 12
#define LIGHTMAGENTA 13
#define YELLOW 14
#define WHITE 15

unsigned long biostime(int dummy1, long dummy2)
{
 return ((GetTickCount() - biostime1) / 55L);
}
/*
unsigned long biostime(int dummy1, long dummy2)
{
 struct timespec biostime2;

 getclock(TIMEOFDAY, &biostime2);
 return ((biostime2.tv_sec-biostime1.tv_sec)*1000L+
         biostime2.tv_nsec/1000000L-biostime1.tv_nsec/1000000L)/55L;
}
*/

void window(int xmin, int ymin, int xmax, int ymax)
{
 WinXMin = xmin - 1;
 WinYMin = ymin - 1;
 WinXMax = xmax - 1;
 WinYMax = ymax - 1;
}

void gotoxy(int x, int y)
{
 COORD xy;

 WinXSav = x;
 WinYSav = y;
 xy.X = WinXMin + x - 1;
 xy.Y = WinYMin + y - 1;
 SetConsoleCursorPosition(hOut, xy);
// printf("\x1B=%c%c", WinYMin+y+0x1E, WinXMin+x+0x1E);
}

void textcolor(int color)
{
 ForeColor = color;
 SetConsoleTextAttribute(hOut, ForeColor + BackColor);
/*
 ForeColor = color & 0x07;
 ForeIntens = color & 0x08;
 printf("\x1B@%c%c", ForeColor, BackColor);
 if (ForeIntens)
  printf("\x1B<");
 else
  printf("\x1B>");
*/ 
}

void textbackground(int color)
{
 BackColor = color;
 SetConsoleTextAttribute(hOut, ForeColor + BackColor);
/*
 BackColor = color & 0x07;
 printf("\x1B@%c%c", ForeColor, BackColor);
*/
}

void clrscr()
{
 int x, y;

 for (y = WinYMin; y<=WinYMax; y++)
 {
  gotoxy(1, y-WinYMin+1);
  for (x=WinXMin; x<=WinXMax; x++)
   putchar(' ');
 } 
 gotoxy(1, 1);
}

void clreol()
{
 int x;
 for (x=WinXMin; x<=WinXMax; x++)
  putchar(' ');
 gotoxy(1, WinYSav);
}

WORD awKeyBuffer[32];
int nKeyBufferStart = 0;
int nKeyBufferLength = 0;

void CheckInput()
{
 DWORD dwResult;
 INPUT_RECORD ir;

 while (WaitForSingleObject(hIn, 0) == WAIT_OBJECT_0)
 {
  ReadConsoleInput(hIn, &ir, 1, &dwResult);
  if (ir.EventType == KEY_EVENT && ir.Event.KeyEvent.bKeyDown)
  {
   if (ir.Event.KeyEvent.wVirtualScanCode == 0x58) //F12
   {
    prtscr_flag = 1;
    continue;
   }
   if (nKeyBufferLength < 32)
    awKeyBuffer[(nKeyBufferStart + nKeyBufferLength++) & 31] = (WORD)ir.Event.KeyEvent.uChar.AsciiChar | (ir.Event.KeyEvent.wVirtualScanCode << 8);
  }
 }
}

unsigned short bioskey()
{
 unsigned short key;

 while (nKeyBufferLength == 0)
  CheckInput();
 key = awKeyBuffer[nKeyBufferStart++];
 nKeyBufferStart &= 31;
 --nKeyBufferLength;
 return key;
}

int kbhit()
{
 CheckInput();
 return (nKeyBufferLength > 0);
}

unsigned short get_timer()
{
 unsigned short t;
/*
 outportb(TIMER_CTRL_PORT, 0x00);
 t = (unsigned short)inportb(TIMER0_PORT);
 t |= (unsigned short)inportb(TIMER0_PORT)<<8;
*/
 return t;
}

int test_start(int test_mode)
{
 int result = 1;
 unsigned short cmdw;
 int fWaitRtIntr;
 unsigned long p;

 switch (test_mode)
 {
// case TEST_RTFL:
// case TEST_SSFL:
// case TEST_BUSY:
// case TEST_SREQ:
 case TEST_DNBA_OFF:
 case TEST_DNBA_ON:
// case TEST_RESET:
 case TEST_SYNC:
 case TEST_GET_VECTOR:
 case TEST_GET_SELFTEST:
 case TEST_SYNC_DATA:
// case TEST_OTHER_AT:
 case TEST_RT_DATA_IRQ:
// case TEST_RT_DATA_IRQ_BL:
  fWaitRtIntr = 1;
  break;
 default:
  fWaitRtIntr = 0;
 }
 if (fWaitRtIntr)
   CheckTmkEvent(NO_WAIT_EVENT);
 int_num[rtnum] = 0;
 start_1("");
 if (fWaitRtIntr)
 {
//   printf("TEST%d", test_mode);
   p = biostime(0, 0L);  /*  뢠 2 (10) ⨪ */
   do
   {
    if (int_num[rtnum] != 0) break;
    CheckTmkEvent(fGlobalWaitEvent);
//    CheckTmkProxy(NO_WAIT_PROXY);
   }
   while (biostime(0, 0L) - p < 10);
 }
 cmdw = bcgetw(0);
 switch (test_mode)
 {
 case TEST_RTFL:
  if (int_num[bcnum] == 2 &&
      bc_aw1 == ((rtadr<<11) | RTFL_MASK) && 1)
//      rt_cmd == SYNC)
  {
   result = 0;
   good_starts++;
   bad_starts--;
  }
  break;
 case TEST_MASK_RTFL:
  if (int_num[bcnum] == 1 && 1)
//      rt_cmd == MASK_RTFL)
   result = 0;
  break;
 case TEST_UNMASK_RTFL:
  if (int_num[bcnum] == 2 &&
      bc_aw1 == ((rtadr<<11) | RTFL_MASK) && 1)
//      rt_cmd == UNMASK_RTFL)
  {
   result = 0;
   good_starts++;
   bad_starts--;
  }
  break;
 case TEST_SSFL:
  if (int_num[bcnum] == 2 &&
      bc_aw1 == ((rtadr<<11) | SSFL_MASK) && 1)
//      rt_cmd == SYNC)
  {
   result = 0;
   good_starts++;
   bad_starts--;
  }
  break;
 case TEST_BUSY:
  if (int_num[bcnum] == 2 &&
      bc_aw1 == ((rtadr<<11) | BUSY_MASK) && 1)
//      rt_cmd == SYNC)
  {
   result = 0;
   good_starts++;
   bad_starts--;
  }
  break;
 case TEST_SREQ:
  if (int_num[bcnum] == 2 &&
      bc_aw1 == ((rtadr<<11) | SREQ_MASK) && 1)
//      rt_cmd == SYNC)
  {
   result = 0;
   good_starts++;
   bad_starts--;
  }
 case TEST_DNBA_OFF:
  if (int_num[bcnum] == 1 &&
      rt_cmd == DNB)
   result = 0;
  break;
 case TEST_DNBA_ON:
  if (int_num[bcnum] == 2 &&
      bc_aw1 == ((rtadr<<11) | DNBA_MASK) &&
      rt_cmd == DNB)
  {
   result = 0;
   good_starts++;
   bad_starts--;
  }
  break;
 case TEST_RESET:
  if (int_num[bcnum] == 1 && 1)
//      rt_cmd == RESET)
   result = 0;
  break;
 case TEST_SYNC:
  if (int_num[bcnum] == 1 &&
      rt_cmd == SYNC
      && int_num[rtnum] == 1)
   result = 0;
  break;
 case TEST_GET_VECTOR:
  if (int_num[bcnum] == 1 &&
      bcgetw(2) == 0xFACE &&
      rt_cmd == GET_VECTOR)
   result = 0;
  break;
 case TEST_GET_SELFTEST:
  if (int_num[bcnum] == 1 &&
      bcgetw(2) == 0xBABA &&
      rt_cmd == GET_SELFTEST)
   result = 0;
  break;
 case TEST_SYNC_DATA:
  if (int_num[bcnum] == 1 &&
      rt_cmd == SYNC_DATA)
  {
   tmkselect(rtnum);
   if (rtgetcmddata(SYNC_DATA) == 0xA5A5)
    result = 0;
   tmkselect(bcnum);
  }
  break;
 case TEST_OTHER_AT:
  if (int_num[bcnum] == 2 &&
      bc_sw == S_TO_MASK)
  {
   result = 0;
   good_starts++;
   bad_starts--;
  }
  break;
 case TEST_AT:
  if (int_num[bcnum] == 1 &&
      bcgetw(1) == (rtadr<<11))
   result = 0;
  break;
 case TEST_BUSY1:
  if (int_num[bcnum] == 2 &&
      ((dir == RT_RECEIVE && bc_sw == S_IB_MASK) ||
       (dir == RT_TRANSMIT && bc_sw == (S_IB_MASK | S_TO_MASK))) &&
        bc_aw1 == ((rtadr<<11) | BUSY_MASK))
  {
   result = 0;
   good_starts++;
   bad_starts--;
  }
  break;
 case TEST_NOBUSY1:
  if (int_num[bcnum] == 1)
  {
   result = 0;
  }
  break;
 case TEST_COUNTER:
  if (int_num[bcnum] == 1)
  {
   result = 0;
  }
  break;
 case TEST_COUNTER_RT_BC:
 case TEST_COUNTER_BC_RT:
  if (int_num[bcnum] == 1 &&
      bc_sw == 0)
  {
   result = 0;
  }
  break;
 case TEST_RT_RT_BRCST:
  if (int_num[bcnum] == 1 &&
      !cmp_ram_buf(0, 3, 32))
  {
   result = 0;
  }
  break;
 case TEST_DNBA:
  if (int_num[bcnum] == 2 &&
      bc_sw == S_IB_MASK &&
      bc_aw1 == ((rtadr<<11) | DNBA_MASK))
  {
   result = 0;
   good_starts++;
   bad_starts--;
  }
  break;
 case TEST_BRCST_CMD:
  if (int_num[bcnum] == 1 &&
      bc_sw == 0)
  {
   result = 0;
  }
  break;
 case TEST_BRCST_BIT:
  if (int_num[bcnum] == 2 &&
      bc_sw == S_IB_MASK &&
      bc_aw1 == ((rtadr<<11) | BRCST_MASK))
  {
   result = 0;
   good_starts++;
   bad_starts--;
  }
  break;
 case TEST_ERROR:
  if (int_num[bcnum] == 2 &&
      bc_sw == S_IB_MASK &&
      bc_aw1 == ((rtadr<<11) | ERROR_MASK))
  {
   result = 0;
   good_starts++;
   bad_starts--;
  }
  break;
 case TEST_SYNC_DATA1:
  if (int_num[bcnum] == 1 &&
      bc_sw == 0)
  {
   result = 0;
  }
  break;
 case TEST_SYNC_DATA_BRCST:
  if (int_num[bcnum] == 1 &&
      bc_sw == 0)
  {
   result = 0;
  }
  break;
 case TEST_NO_RT_15:
  if (int_num[bcnum] == 2 &&
      bc_sw == S_TO_MASK)
  {
   result = 0;
   good_starts++;
   bad_starts--;
  }
  break;
 case TEST_RT_15:
  if (int_num[bcnum] == 1 &&
      bc_sw == 0)
  {
   result = 0;
  }
  break;
 case TEST_NO_RT_0A:
  if (int_num[bcnum] == 2 &&
      bc_sw == S_TO_MASK)
  {
   result = 0;
   good_starts++;
   bad_starts--;
  }
  break;
 case TEST_RT_0A:
  if (int_num[bcnum] == 1 &&
      bc_sw == 0)
  {
   result = 0;
  }
  break;
 case TEST_BLOCK_TR:
 case TEST_UNBLOCK_TR:
  if (int_num[bcnum] == 1 &&
      bc_sw == 0)
  {
   result = 0;
  }
  break;
 case TEST_BLOCKED_TR:
  if (int_num[bcnum] == 2 &&
      bc_sw == S_TO_MASK)
  {
   result = 0;
   good_starts++;
   bad_starts--;
  }
  break;
 case TEST_UNBLOCKED_TR:
  if (int_num[bcnum] == 1 &&
      bc_sw == 0)
  {
   result = 0;
  }
  break;
 case TEST_RT_DATA_IRQ:
  if (int_num[bcnum] == 1 &&
      int_num[rtnum] == 3)
  {
   result = 0;
  }
  break;
 case TEST_RT_DATA_IRQ_BL:
  if (int_num[bcnum] == 1 &&
      int_num[rtnum] == 0)
  {
   result = 0;
  }
  break;
 }
 return result;
}

void make_test1(int start)
{
 unsigned short data;
 int k;

 data = 0;
 for (k = start; k <= start+31; k++)
 {
  buffer[k] = data;
  switch (data)
  {
  case 0x0000:
   data = 0x0001;
   break;
  case 0x8000:
   data = 0xAAAA;
   break;
  case 0xAAAA:
   data = 0x5555;
   break;
  case 0x5555:
   data = 0xAAAA;
   break;
  default:
   data <<= 1;
  }
 }
}

/************************************************************************/
/*                      砫 ᥪ樨                              */
/************************************************************************/

void avt_bc(char *str)                  /* প ஢ન  */
{
 int k, maxbase, err;
 unsigned long times, nBusSwapTime;

 while (*str == '\t' || *str == ' ') str++;
 if (*str)
 {
  if (sscanf(str, "%U", &times) != 1)
  {
   msg_out(inp_err);
   return;
  }
 }
 else
  times=1;
 if (Window[0].nMode == BC_MODE)
  bcwin = 0;
 else if (Window[1].nMode == BC_MODE)
  bcwin = 1;
 else
 {
  msg_out("    ० ");
  return;
 }
 if (Window[0].nMode == RT_MODE)
  rtwin = 0;
 else if (Window[1].nMode == RT_MODE)
  rtwin = 1;
 else
 {
  msg_out("    ० ");
  return;
 }
 bcnum = Window[bcwin].nTMK;
 rtnum = Window[rtwin].nTMK;
 avt_ctrl("1");
 avt_ok = 0;
 select_window(bcwin);
 if (fReserv)
 {
  nReservBus = ((nMainBus=bcgetbus()) == BUS_A) ? BUS_B : BUS_A;
  bus_num = nMainBus;
  out_number();
  nBusSwapTime = times+1;
  times <<= 1;
 }
 select_window(rtwin);
 wr_at(rtadr=0x0A); out_at();
 set_status_word("0"); /*     */
 select_window(rtwin);
 comment("⮬᪨  ஫ .");
 select_window(bcwin);
 statistic_clear("");
 if (hb_mode)
 {
  subadr1 = 0x10;
  subadr2 = 0x1E;
  ci_field = 0x1F<<5;
 }
 else
 {
  subadr1 = 0x01;
  subadr2 = 0x1E;
  ci_field = 0;
 }
 do
 {
  select_window(bcwin);
  maxbase = bcgetmaxbase();
  buf_clear("");
  srand(1);
  subadr = subadr1;
  for (base = 0; base <= maxbase; base++)
  {
   bcdefbase(base);
   buffer[0] = (rtadr<<11) | (RT_RECEIVE) | (subadr<<5);
   buffer[1] = base | (base<<8);
   for (k = 2; k <= 32; k++)
    buffer[k] = rand() + rand();
   bcputblk(0, buffer, 33);
   if (++subadr > subadr2)
    subadr = subadr1;
  }
  ctrl_code = DATA_BC_RT;
  subadr = subadr1;
  srand(1);
  err = 0;
  for (base = 0; base <= maxbase; base++)
  {
   select_window(bcwin);
   if (start_1(""))
   {
    err_msg = " 諠 । ⮢ ᨢ    ";
    goto fin;
   }
   select_window(rtwin);
   rtdefsubaddr(RT_RECEIVE, subadr);
   rtgetblk(0, buffer, 32);
   if (buffer[0] != (unsigned short)(base | (base<<8)))
   {
    err = 1;
    break;
   }
   for (k = 1; k <= 31; k++)
    if (buffer[k] != rand() + rand())
    {
     err = 1;
     break;
    }
   if (err)
    break;
   if (++subadr > subadr2)
    subadr = subadr1;
  }
  if (err)
  {
   err_msg = "⮢ ᨢ ।    訡";
   goto fin;
  }
  select_window(bcwin);
  bc_clear_ram();
  srand(1);
  subadr = subadr1;
  ctrl_code = DATA_RT_BC;
  for (base = 0; base <= maxbase; base++)
  {
   select_window(rtwin);
   rtdefsubaddr(RT_TRANSMIT, subadr);
   buffer[0] = base | (base<<8);
   for (k = 1; k <= 31; k++)
    buffer[k] = rand() + rand();
   rtputblk(0, buffer, 32);
   select_window(bcwin);
   bcdefbase(base);
   bcputw(0, CW(rtadr, RT_TRANSMIT, subadr, 32));
   if (start_1(""))
   {
    err_msg = " 襫 ਥ ⮢ ᨢ    ";
    goto fin;
   }
   if (++subadr > subadr2)
    subadr = subadr1;
  }
  srand(1);
  select_window(bcwin);
  for (base = 0; base <= maxbase; base++)
  {
   bcdefbase(base);
   bcgetblk(2, buffer, 32);
   if (buffer[0] != (unsigned short)(base | (base<<8)))
   {
    err = 1;
    break;
   }
   for (k = 1; k <= 31; k++)
    if (buffer[k] != rand() + rand())
    {
     err = 1;
     break;
    }
   if (err)
    break;
   if (++subadr > subadr2)
    subadr = subadr1;
  }
  if (err)
  {
   err_msg = "⮢ ᨢ ਭ    訡";
   goto fin;
  }
 /* ஢ 稪  */
  select_window(rtwin);
  rtdefsubaddr(dir=RT_TRANSMIT, subadr=0x10);
  for (k = 0; k <= 31; k++)
   buffer[k] = k+1;
  rtputblk(0, buffer, 32);
  select_window(bcwin);
  bcdefbase(1);
  bcputblk(1, buffer, 32);
  bcdefbase(base=0);
  ctrl_code = DATA_RT_BC;
  for (len = 1; len <= 32; len++)
  {
   bcputw(0, CW(rtadr, RT_TRANSMIT, subadr, len));
   if (test_start(TEST_COUNTER_RT_BC))
   {
    err_msg = " 襫  稪   ० ->";
    goto fin;
   }
  }
  ctrl_code = DATA_BC_RT;
  bcdefbase(base=1);
  for (len = 1; len <= 32; len++)
  {
   bcputw(0, CW(rtadr, RT_RECEIVE, subadr, len));
   if (test_start(TEST_COUNTER_BC_RT))
   {
    err_msg = " 襫  稪   ० ->";
    goto fin;
   }
  }
 /* ଠ - (㯯 ०),  - 17 */
  make_test1(3);
  select_window(rtwin);
  rtdefsubaddr(dir=RT_TRANSMIT, subadr=0x17);
  rtputblk(0, buffer+3, 32);
  select_window(bcwin);
  ctrl_code = DATA_RT_RT_BRCST;
  bcdefbase(base=2);
  bcputw(0, CW(0x1F, RT_RECEIVE, subadr, 32));
  bcputw(1, CW(rtadr, RT_TRANSMIT, subadr, 32));
  if (start_loop_n(GL_COUNTER))
  {
   err_msg = " 襫  ଠ ->  㯯 ०";
   goto fin;
  }
  select_window(rtwin);
  if (cmp_ram_buf(3, 0, 32))
  {
   err_msg = "⮢ ᨢ  ଠ ->  㯯 ० ਭ  訡";
   goto fin;
  }
 /* ஢ઠ ⮢ ⢥⭮ ᫮ */
  select_window(bcwin);
  base = 3;
  bcdefbase(base);
  buf_clear("");
  select_window(rtwin);
  rtsetanswbits(RTFL); out_status_word();
  select_window(bcwin);
  ctrl_code = CTRL_C_A;
  bcputw(0, CWMC(rtadr, ci_field, UNBLOCK_TRANSMIT));
  if (test_start(TEST_RTFL))
  {
   err_msg = " 襫  ਥ   ⮬ 'ࠢ ନ'";
   goto fin;
  }
  select_window(rtwin);
  rtclranswbits(RTFL); rtsetanswbits(SSFL);
  select_window(bcwin);
  if (test_start(TEST_SSFL))
  {
   err_msg = " 襫  ਥ   ⮬ 'ࠢ ⥬'";
   goto fin;
  }
  select_window(rtwin);
  rtclranswbits(SSFL); rtsetanswbits(BUSY);
  select_window(bcwin);
  if (test_start(TEST_BUSY))
  {
   err_msg = " 襫  ਥ   ⮬ '⥬ '";
   goto fin;
  }
  select_window(rtwin);
  rtclranswbits(BUSY); rtsetanswbits(SREQ);
  select_window(bcwin);
  if (test_start(TEST_SREQ))
  {
   err_msg = " 襫  ਥ   ⮬ ' 㦨'";
   goto fin;
  }
  select_window(rtwin);
  rtclranswbits(SREQ); rtsetanswbits(DNBA);
  select_window(bcwin);
  bcputw(0, CWMC(rtadr, ci_field, DNB));
  if (test_start(TEST_DNBA))
  {
   err_msg = " 襫  ਥ   ⮬ 'ਭ ࠢ '";
   goto fin;
  }
 /*    室 ﭨ */
  select_window(rtwin);
  rtclranswbits(DNBA); out_status_word();
  select_window(bcwin);
  ctrl_code = CTRL_C_BRCST;
  bcputw(0, CWMC(0x1F, ci_field, RESET));
  if (test_start(TEST_BRCST_CMD))
  {
   err_msg = " 襫  '.室 ﭨ , 㯯 ०'";
   goto fin;
  }
 /* ஢ઠ  㯯  */
  ctrl_code = CTRL_C_A;
  bcputw(0, CWMC(rtadr, ci_field, GET_SW));
  if (test_start(TEST_BRCST_BIT))
  {
   err_msg = " 襫  ਥ   ⮬ 'ਭ 㯯 '";
   goto fin;
  }
 /* ஢ઠ  訡  ᮮ饭 */
  bcputw(0, (TMK_DATA)(~RT_DIR_MASK & CWMC(rtadr, ci_field, SYNC)));
  if (test_start(TEST_ERROR))
  {
   err_msg = " 襫  ਥ   ⮬ '訡 ᮮ饭'";
   goto fin;
  }
 /* ஭  ᫮ AAAA */
  ctrl_code = CTRL_CD_A;
  bcputw(0, CWMC(rtadr, ci_field, SYNC_DATA));
  bcputw(1, 0xAAAA);
  if (test_start(TEST_SYNC_DATA1))
  {
   err_msg = " 襫  '஭  ᫮ AAAAh'";
   goto fin;
  }
  ctrl_code = CTRL_CD_BRCST;
  bcputw(0, CWMC(0x1F, ci_field, SYNC_DATA));
  bcputw(1, 0x5555);
  if (test_start(TEST_SYNC_DATA_BRCST))
  {
   err_msg = " 襫  '஭  ᫮ 5555h, 㯯 ०'";
   goto fin;
  }
  ctrl_code = CTRL_C_A;
  bcputw(0, CWMC(rtadr, ci_field, RESET));
  if (test_start(TEST_BRCST_CMD))
  {
   err_msg = " 襫  ਥ   ⮬ 'ਭ 㯯 '";
   goto fin;
  }
  all_screen();
  if (Window[rtwin].at_avail)
  {
   rtadr1 = 0x15;
   rtadr2 = 0x0A;
  }
  else
  {
 #ifdef STEND
   rtadr1 = 0x15;
   rtadr2 = 0x0A;
 #else
   rtadr1 = (rtadr == 0) ? 0x1E : rtadr ^ 0x1F;
   rtadr2 = rtadr;
 #endif
  }
 /* 饭e  饬  c ᮬ 0x15 */
  ctrl_code = CTRL_C_A;
  bcputw(0, CWMC(rtadr1, ci_field, GET_SW));
  if (test_start(TEST_NO_RT_15))
  {
   err_msg = " 襫  饭  饬 ";
   goto fin;
  }
 #ifndef STEND
  if (Window[rtwin].at_avail)
 #endif
  {
   select_window(rtwin);
   wr_at(rtadr = rtadr1);
   select_window(bcwin);
 /* 饭    ᮬ 0x15 */
   if (test_start(TEST_RT_15))
   {
    err_msg = " 襫  饭    ᮬ 15h (10101)";
    goto fin;
   }
 /* 饭e  饬  c ᮬ 0x0A */
   bcputw(0, CWMC(rtadr2, ci_field, GET_SW));
   if (test_start(TEST_NO_RT_0A))
   {
    err_msg = " 襫  饭  饬   ᮬ 0Ah (01010)";
    goto fin;
   }
  }
  select_window(rtwin);
  wr_at(rtadr = rtadr2);
  select_window(bcwin);
 /* 饭    ᮬ 0x0A */
  bcputw(0, CWMC(rtadr2, ci_field, GET_SW));
  if (test_start(TEST_RT_0A))
  {
   err_msg = " 襫  饭  ";
   goto fin;
  }
  int_num[rtnum] = 0;
  select_window(rtwin);
  wr_at(rtadr);
  rt_clear_ram();
  select_window(bcwin);
  bc_clear_ram();
  if (fAAAA)
   if (statistic_rt_bc(0x10, 0, 0xAAAA)) goto bad_statistic;
  if (statistic_rt_bc(0x12, 2, 0x0000)) goto bad_statistic;
  if (statistic_rt_bc(0x14, 4, 0x5555)) goto bad_statistic;
  if (statistic_rt_bc(0x16, 6, 0xFFFF)) goto bad_statistic;
  if (fAAAA)
   if (statistic_rt_bc(0x18, 8, 0x8000)) goto bad_statistic;
  if (statistic_rt_bc(0x1A, 10, 0x7FFF)) goto bad_statistic;
  if (statistic_bc_rt(12, 0x10, 0xAAAA)) goto bad_statistic;
  if (statistic_bc_rt(14, 0x12, 0x0000)) goto bad_statistic;
  if (statistic_bc_rt(16, 0x14, 0x5555)) goto bad_statistic;
  if (statistic_bc_rt(18, 0x16, 0xFFFF)) goto bad_statistic;
  if (statistic_bc_rt(20, 0x18, 0x8000)) goto bad_statistic;
  if (statistic_bc_rt(22, 0x1A, 0x7FFF)) goto bad_statistic;
  select_window(bcwin);
  if (fReserv && (times == nBusSwapTime || times == 1))
  {
   unsigned short nTempBus;
   bcdefbus(nReservBus);
   nTempBus = nMainBus;
   nMainBus = nReservBus;
   nReservBus = nTempBus;
   bus_num = nMainBus;
   out_number();
  }
 }
 while (--times);
/*   */
 avt_ok = 1;
 err_msg = " ஫  襭";
 goto fin;
 bad_statistic:
 err_msg = " 襫  ' ⨪'";
 fin:
 if (prtscr_flag)
 {
  prtscr_flag = 0;
  err_msg = " ࢠ  PrtScr";
 }
 check_int();
 select_window(bcwin);
 all_screen();
 select_window(rtwin);
 putchar('\007');
 
 if (avt_ok)
  textcolor(GREEN);
 else
  textcolor(LIGHTRED);
 comment(err_msg);
 textcolor(LIGHTGRAY);
 select_window(nmainwin=bcwin);
 statistic_out("");
 avt_ctrl("0");
}

/************************************************************************/
/*                      砫 ᥪ樨                              */
/************************************************************************/

int test_rt_busy()
{
 int test_result;

 test_result = 1;
 rtdefsubaddr(dir = RT_TRANSMIT, subadr = 0x11);
// rtunlock();
 select_window(bcwin);
 bcdefbase(base);
 ctrl_code = DATA_RT_BC;
 bcputw(0, CW(rtadr, RT_TRANSMIT, subadr, 32));
 int_num[bcnum] = 0;
 bcstart(base, ctrl_code);
 tmkselect(rtnum);
 do
 {
  if (rtbusy()) test_result = 0;
  CheckTmkEvent(NO_WAIT_EVENT);
//  CheckTmkProxy(NO_WAIT_PROXY);
 }
 while (!int_num[bcnum]);
 select_window(rtwin);
 return test_result;
}

void avt_rt(char *str)                   /* প ஢ન  */
{
 int maxpage, k;
 TMK_DATA page;
 unsigned long times, nBusSwapTime;

 while (*str == '\t' || *str == ' ') str++;
 if (*str)
 {
  if (sscanf(str, "%U", &times) != 1)
  {
   msg_out(inp_err);
   return;
  }
 }
 else
  times=1;
 if (Window[0].nMode == RT_MODE)
  rtwin = 0;
 else if (Window[1].nMode == RT_MODE)
  rtwin = 1;
 else
 {
  msg_out("    ० ");
  return;
 }
 if (Window[0].nMode == BC_MODE)
  bcwin = 0;
 else if (Window[1].nMode == BC_MODE)
  bcwin = 1;
 else
 {
  msg_out("    ० ");
  return;
 }
 bcnum = Window[bcwin].nTMK;
 rtnum = Window[rtwin].nTMK;
 statistic_clear("");
 avt_ctrl("1");
 avt_ok = 0;
 select_window(bcwin);
 if (fReserv)
 {
  nReservBus = ((nMainBus=bcgetbus()) == BUS_A) ? BUS_B : BUS_A;
  bus_num = nMainBus;
  out_number();
  nBusSwapTime = times+1;
  times <<= 1;
 }
 select_window(rtwin);
 comment("⮬᪨  筮 ன⢠.");
 wr_at(rtadr=0x0A); out_at();
 set_status_word("0"); /*     */
 maxpage = rtgetmaxpage();
 if (hb_mode)
 {
  subadr1 = 0x10;
  subadr2 = 0x1E;
  ci_field = CI_MASK;
 }
 else
 {
  subadr1 = 0x01;
  subadr2 = 0x1E;
  ci_field = 0;
 }
 do
 {
  select_window(rtwin);
  srand(1);
  for (page = 0; page <= maxpage; page++)
  {
   rtdefpage(page);
   for(subadr = subadr1; subadr <= subadr2; subadr++)
   {
    rtdefsubaddr(RT_TRANSMIT, subadr);
    buffer[0] = (page<<14) | (subadr<<8) | (page<<6) | subadr | 0x2020;
    for (k = 1; k <= 31; k++)
     buffer[k] = rand() + rand();
    rtputblk(0, buffer, 32);
   }
  }
  srand(1);
  for (page = 0; page <= maxpage; page++)
  {
   select_window(rtwin);
   rtdefpage(page);
   select_window(bcwin);
   bcdefbase(base=0);
   for(subadr = subadr1; subadr <= subadr2; subadr++)
   {
    ctrl_code = DATA_RT_BC;
    bcputw(0, CW(rtadr, RT_TRANSMIT, subadr, 32));
    if (start_1(""))
    {
     err_msg = " 諠 । ⮢ ᨢ    ";
     goto fin;
    }
    vbuffer[0] = (page<<14) | (subadr<<8) | (page<<6) | subadr | 0x2020;
    for (k = 1; k <= 31; k++)
     vbuffer[k] = rand() + rand();
    if (cmp_ram_buf(2, -1, 32))
    {
     err_msg = "⮢ ᨢ ।    訡";
     goto fin;
    }
   }
  }
  for (page = 0; page <= maxpage; page++)
  {
   select_window(rtwin);
   rtdefpage(page);
   select_window(bcwin);
   bcdefbase(base=1);
   for(subadr = subadr1; subadr <= subadr2; subadr++)
   {
    ctrl_code = DATA_BC_RT;
    buffer[0] = (rtadr<<11) | RT_RECEIVE | (subadr<<5);
    buffer[1] = (page<<14) | (subadr<<8) | (page<<6) | subadr;
    for (k = 2; k <= 32; k++)
     buffer[k] = rand() + rand();
    bcputblk(0, buffer, 33);
    if (start_1(""))
    {
     err_msg = " 襫 ਥ ⮢ ᨢ    ";
     goto fin;
    }
   }
  }
  srand(1);
  select_window(rtwin);
  for (page = 0; page <= maxpage; page++)
  {
   rtdefpage(page);
   for (subadr = subadr1; subadr <= subadr2; subadr++)
   {
    buffer[0] = (page<<14) | (subadr<<8) | (page<<6) | subadr | 0x2020;
    for (k = 1; k <= 31; k++)
     buffer[k] = rand() + rand();
    rtdefsubaddr(RT_TRANSMIT, subadr);
    if (cmp_ram_buf(0, 0, 32))
    {
     err_msg = " ਥ ⮢ ᨢ       ।";
     goto fin;
    }
   }
  }
  for (page = 0; page <= maxpage; page++)
  {
   rtdefpage(page);
   for (subadr = subadr1; subadr <= subadr2; subadr++)
   {
    buffer[0] = (page<<14) | (subadr<<8) | (page<<6) | subadr;
    for (k = 1; k <= 31; k++)
     buffer[k] = rand() + rand();
    rtdefsubaddr(RT_RECEIVE, subadr);
    if (cmp_ram_buf(0, 0, 32))
    {
     err_msg = "⮢ ᨢ ਭ    訡";
     goto fin;
    }
   }
  }
  set_page("0");
 /* ஢ઠ ⮢ ⢥⭮ ᫮ */
  rtsetanswbits(RTFL); /* TF */
  select_window(bcwin);
  ctrl_code = CTRL_C_A;
  bcputw(0, CWMC(rtadr, ci_field, SYNC));
  if (test_start(TEST_RTFL))
  {
   err_msg = " ⠭    'ࠢ ନ'";
   goto fin;
  }
  bcputw(0, CWMC(rtadr, ci_field, MASK_RTFL));
  if (test_start(TEST_MASK_RTFL))
  {
   err_msg = " 諠  '  ନ'";
   goto fin;
  }
  bcputw(0, CWMC(rtadr, ci_field, UNMASK_RTFL));
  if (test_start(TEST_UNMASK_RTFL))
  {
   err_msg = " 諠  '⬥   ନ'";
   goto fin;
  }
  select_window(rtwin);
  rtclranswbits(RTFL); /* TF */
  rtsetanswbits(SSFL); /* SF */
  select_window(bcwin);
  bcputw(0, CWMC(rtadr, ci_field, SYNC));
  if (test_start(TEST_SSFL))
  {
   err_msg = " ⠭    'ࠢ ⥬'";
   goto fin;
  }
  select_window(rtwin);
  rtclranswbits(SSFL); /* SF */
  rtsetanswbits(BUSY); /* BS */
  select_window(bcwin);
  bcputw(0, CWMC(rtadr, ci_field, SYNC));
  if (test_start(TEST_BUSY))
  {
   err_msg = " ⠭    '⥬ '";
   goto fin;
  }
  select_window(rtwin);
  rtclranswbits(BUSY); /* BS */
  rtsetanswbits(SREQ); /* SR */
  select_window(bcwin);
  bcputw(0, CWMC(rtadr, ci_field, SYNC));
  if (test_start(TEST_SREQ))
  {
   err_msg = " ⠭    ' 㦨 ⥬'";
   goto fin;
  }
  select_window(rtwin);
  rtclranswbits(SREQ); /* SR */
  select_window(bcwin);
  bcputw(0, CWMC(rtadr, ci_field, DNB));
  if (test_start(TEST_DNBA_OFF))
  {
   err_msg = "⠭    'ਭ ࠢ '  ࠧ襭 ";
   goto fin;
  }
  select_window(rtwin);
  rtsetanswbits(DNBA); /* DN */
  select_window(bcwin);
  bcputw(0, CWMC(rtadr, ci_field, DNB));
  if (test_start(TEST_DNBA_ON))
  {
   err_msg = " ⠭    'ਭ ࠢ '";
   goto fin;
  }
  select_window(rtwin);
  rtclranswbits(DNBA); /*  DN */
  select_window(bcwin);
  bcputw(0, CWMC(rtadr, ci_field, RESET));
  if (test_start(TEST_RESET))
  {
   err_msg = " ᨫ    'ਭ ࠢ ' ᫥  ' '";
   goto fin;
  }
  if (fReserv)
  {
   bcputw(0, CWMC(rtadr, ci_field, BLOCK_TRANSMIT));
   if (test_start(TEST_BLOCK_TR))
   {
    err_msg = " 諠 1 ஢ ।稪";
    goto fin;
   }
   bcdefbus(nReservBus);
   ctrl_code = DATA_RT_BC;
   bcputw(0, CW(rtadr, RT_TRANSMIT, 0x10, 1));
   if (test_start(TEST_BLOCKED_TR))
   {
    err_msg = " 襫 1 ஢ ।稪";
    goto fin;
   }
   ctrl_code = CTRL_C_A;
   bcputw(0, CWMC(rtadr, ci_field, RESET));
   if (test_start(TEST_RESET))
   {
    err_msg = " 襫    ஢ ";
    goto fin;
   }
   ctrl_code = DATA_RT_BC;
   bcputw(0, CW(rtadr, RT_TRANSMIT, 0x10, 1));
   if (test_start(TEST_UNBLOCKED_TR))
   {
    err_msg = " 襫 1 ࠧ஢ ।稪";
    goto fin;
   }
   bcdefbus(nMainBus);
   ctrl_code = CTRL_C_A;
   bcputw(0, CWMC(rtadr, ci_field, BLOCK_TRANSMIT));
   if (test_start(TEST_BLOCK_TR))
   {
    err_msg = " 諠 2 ஢ ।稪";
    goto fin;
   }
   bcdefbus(nReservBus);
   ctrl_code = DATA_RT_BC;
   bcputw(0, CW(rtadr, RT_TRANSMIT, 0x10, 1));
   if (test_start(TEST_BLOCKED_TR))
   {
    err_msg = " 襫 2 ஢ ।稪";
    goto fin;
   }
   bcdefbus(nMainBus);
   ctrl_code = CTRL_C_A;
   bcputw(0, CWMC(rtadr, ci_field, UNBLOCK_TRANSMIT));
   if (test_start(TEST_UNBLOCK_TR))
   {
    err_msg = " 諠 2 ࠧ஢ ।稪";
    goto fin;
   }
   bcdefbus(nReservBus);
   ctrl_code = DATA_RT_BC;
   bcputw(0, CW(rtadr, RT_TRANSMIT, 0x10, 1));
   if (test_start(TEST_UNBLOCKED_TR))
   {
    err_msg = " 襫 2 ࠧ஢ ।稪";
    goto fin;
   }
   bcdefbus(nMainBus);
  }
  ctrl_code = CTRL_C_A;
  bcputw(0, CWMC(rtadr, ci_field, SYNC));
  if (test_start(TEST_SYNC))
  {
   err_msg = " 諠  '஭'";
   goto fin;
  }
  select_window(rtwin);
  rtputcmddata(GET_VECTOR, 0xFACE);
  rtputcmddata(GET_SELFTEST, 0xBABA);
  select_window(bcwin);
  ctrl_code = CTRL_C_AD;
  bcputw(0, CWMC(rtadr, ci_field, GET_VECTOR));
  if (test_start(TEST_GET_VECTOR))
  {
   err_msg = " 諠  ' ୮ ᫮'";
   goto fin;
  }
  bcputw(0, CWMC(rtadr, ci_field, GET_SELFTEST));
  if (test_start(TEST_GET_SELFTEST))
  {
   err_msg = " 諠  ' ᫮ ஥ ஫'";
   goto fin;
  }
 /* ஭  ᫮ A5A5 */
  ctrl_code = CTRL_CD_A;
  bcputw(0, CWMC(rtadr, ci_field, SYNC_DATA));
  bcputw(1, 0xA5A5);
  if (test_start(TEST_SYNC_DATA))
  {
   err_msg = " 諠  '஭  ᫮ A5A5h'";
   goto fin;
  }
 /* ஢ઠ ॣ  ନ */
  ctrl_code = CTRL_C_A;
  for (rtadr1 = 1; rtadr1 != 32; rtadr1 <<= 1)
  {
   if (rtadr == rtadr1) continue;
   bcputw(0, CWMC(rtadr1, ci_field, SYNC));
   if (test_start(TEST_OTHER_AT))
   {
    err_msg = " 襫  '饭  `㦮`  '";
    goto fin;
   }
  }
 #ifndef STEND
  if (Window[rtwin].at_avail)
 #endif
  {
   ctrl_code = CTRL_C_A;
   for (rtadr = 1; rtadr != 32; rtadr <<= 1)
   {
    select_window(rtwin);
    wr_at(rtadr);
    select_window(bcwin);
    bcputw(0, CWMC(rtadr, ci_field, SYNC));
    if (test_start(TEST_AT))
    {
     err_msg = " 襫   ";
     goto fin;
    }
   }
  }
  select_window(rtwin);
  wr_at(rtadr = 0x0A);
  avt_out = 0;
 /* ஢ઠ ࡨ 㯠   */
  for (subadr0 = subadr1; subadr0 <= subadr2; subadr0++)
  {
   rtdefsubaddr(RT_TRANSMIT, subadr0);
   rtputw(0, 0x0000);
  }
  for (dir = RT_RECEIVE; ; dir = RT_TRANSMIT)
  {
   for (subadr = subadr1; ;)
   {
    for (subadr0 = subadr1; subadr0 <= subadr2; subadr0++)
    {
     rtdefsubaddr(RT_RECEIVE, subadr0);
     rtputw(0, 0x0000);
    }
    rtlock(dir, subadr);
    fLock=1;
    out_subadr();
    if (rtbusy())
    {
     err_msg = " 뢠  ࠧ襭 㯠   ";
     goto fin;
    }
    select_window(bcwin);
    for (dir0 = RT_RECEIVE; ; dir0 = RT_TRANSMIT)
    {
     ctrl_code = (dir0 == RT_TRANSMIT) ? DATA_RT_BC : DATA_BC_RT;
     for (subadr0 = subadr1; subadr0 <= subadr2; subadr0++)
     {
      bcputw(0, CW(rtadr, dir0, subadr0, 1));
      bcputw(1, 0xFFFF);
      bcputw(2, 0xFFFF);
      if (dir0 == dir && subadr0 == subadr)
      {
       if (test_start(TEST_BUSY1))
       {
        err_msg = " 襫  ࡨ  '饭   ஢ '";
        goto fin;
       }
      }
      else
      {
       if (test_start(TEST_NOBUSY1))
       {
        err_msg = " 襫  ࡨ  '饭   ஢ '";
        goto fin;
       }
      }
     }
     if (dir0 == RT_TRANSMIT) break;
    }
    select_window(rtwin);
    if (dir == RT_RECEIVE)
     if (rtgetw(0) != 0x0000)
     {
      err_msg = " 襫  ࡨ  '饭   ஢ '";
      goto fin;
     }
    rtdefsubaddr(dir, subadr);
//    rtunlock(dir, subadr);
    fLock=0;
    select_window(bcwin);
    dir0 = dir; subadr0 = subadr;
    ctrl_code = (dir0 == RT_TRANSMIT) ? DATA_RT_BC : DATA_BC_RT;
    bcputw(0, CW(rtadr, dir0, subadr0, 1));
    bcputw(1, 0xFFFF);
    bcputw(2, 0xFFFF);
    if (test_start(TEST_NOBUSY1))
    {
     err_msg = " 襫  ࡨ  '饭   ࠧ஢ '";
     goto fin;
    }
    select_window(rtwin);
    for (subadr0 = subadr1; subadr0 <= subadr2; subadr0++)
    {
     rtdefsubaddr(RT_RECEIVE, subadr0);
     if (rtgetw(0) != 0xFFFF)
     {
      err_msg = " 襫  ࡨ  '饭   ࠧ஢ '";
      goto fin;
     }
    }
    if (subadr == 0x18)
     break;
    if (subadr == 0x10)
     subadr = 0x11;
    else
     subadr = ((subadr & 0x0F) << 1) | (subadr & 0x10);
   }
   if (dir == RT_TRANSMIT) break;
  }
 /* ஢ઠ  㯠       */
  if (test_rt_busy())
  {
   err_msg = " ⠭   㯠      ";
   goto fin;
  }
  avt_out = 1;
 /* ஢ 稪  */
  select_window(rtwin);
  rtdefsubaddr(dir=RT_TRANSMIT, subadr=0x10);
  for (k = 0; k <= 31; k++)
   buffer[k] = k+1;
  rtputblk(0, buffer, 32);
  select_window(bcwin);
  ctrl_code = DATA_RT_BC;
  for (len = 1; len <= 32; len++)
  {
   bcputw(0, CW(rtadr, RT_TRANSMIT, subadr, len));
   if (test_start(TEST_COUNTER))
   {
    err_msg = " 襫  稪 ";
    goto fin;
   }
  }
  select_window(rtwin);
  if (rtdefirqmode(RT_GENER1_BL|RT_GENER2_BL) == 0)
  {
   int_num[rtnum]=0;
   select_window(bcwin);
   ctrl_code = DATA_BC_RT;
   bcputw(0, CW(rtadr, RT_RECEIVE, subadr, 32));
   if (test_start(TEST_RT_DATA_IRQ))
   {
//    err_msg = " 襫  뢠   ਥ ";
    int sav_int = int_num[rtnum];
    CheckTmkEvent(NO_WAIT_EVENT);
//    CheckTmkProxy(NO_WAIT_PROXY);
    sprintf(err_msg, " 襫  뢠   ਥ  %d %d.", sav_int, int_num[rtnum]);
    goto fin;
   }
   select_window(rtwin);
   rtdefirqmode(RT_GENER1_BL|RT_GENER2_BL|RT_DATA_BL);
   int_num[rtnum]=0;
   select_window(bcwin);
   if (test_start(TEST_RT_DATA_IRQ_BL))
   {
    err_msg = " 襫  ஢ 뢠   ਥ ";
    goto fin;
   }
   select_window(rtwin);
   rtdefirqmode(RT_GENER1_BL|RT_GENER2_BL);
   int_num[rtnum]=0;
   select_window(bcwin);
   ctrl_code = DATA_RT_BC;
   bcputw(0, CW(rtadr, RT_TRANSMIT, subadr, 32));
   if (test_start(TEST_RT_DATA_IRQ))
   {
    err_msg = " 襫  뢠   । ";
    goto fin;
   }
   select_window(rtwin);
   rtdefirqmode(RT_GENER1_BL|RT_GENER2_BL|RT_DATA_BL);
   int_num[rtnum]=0;
   select_window(bcwin);
   if (test_start(TEST_RT_DATA_IRQ_BL))
   {
    err_msg = " 襫  ஢ 뢠   । ";
    goto fin;
   }
  }
 /*  .- */
  select_window(rtwin);
  rtdefsubaddr(dir=RT_TRANSMIT, subadr=0x10);
  make_test1(0);
  rtputblk(0, buffer, 32);
  select_window(bcwin);
  bcdefbase(base=3);
  ctrl_code = DATA_RT_RT_BRCST;
  bcputw(0, CW(0x1F, RT_RECEIVE, subadr, 32));
  bcputw(1, CW(rtadr, RT_TRANSMIT, subadr, 32));
  if (start_loop_n(GL_COUNTER))
  {
   err_msg = " 襫  ଠ ->  㯯 ०";
   goto fin;
  }
  select_window(rtwin);
  rtgetblk(0, buffer, 32);
  select_window(bcwin);
  if (cmp_ram_buf(0, 3, 32))
  {
   err_msg = "⮢ ᨢ  ଠ ->  㯯 ० ।  訡";
   goto fin;
  }
  int_num[rtnum] = 0;
  select_window(rtwin);
  wr_at(rtadr);
  rt_clear_ram();
  select_window(bcwin);
  bc_clear_ram();
  if (fAAAA)
   if (statistic_rt_bc(0x10, 0, 0xAAAA)) goto bad_statistic;
  if (statistic_rt_bc(0x12, 2, 0x0000)) goto bad_statistic;
  if (statistic_rt_bc(0x14, 4, 0x5555)) goto bad_statistic;
  if (statistic_rt_bc(0x16, 6, 0xFFFF)) goto bad_statistic;
  if (fAAAA)
   if (statistic_rt_bc(0x18, 8, 0x8000)) goto bad_statistic;
  if (statistic_rt_bc(0x1A, 10, 0x7FFF)) goto bad_statistic;
  if (statistic_bc_rt(12, 0x10, 0xAAAA)) goto bad_statistic;
  if (statistic_bc_rt(14, 0x12, 0x0000)) goto bad_statistic;
  if (statistic_bc_rt(16, 0x14, 0x5555)) goto bad_statistic;
  if (statistic_bc_rt(18, 0x16, 0xFFFF)) goto bad_statistic;
  if (statistic_bc_rt(20, 0x18, 0x8000)) goto bad_statistic;
  if (statistic_bc_rt(22, 0x1A, 0x7FFF)) goto bad_statistic;
  select_window(bcwin);
  if (fReserv && (times == nBusSwapTime || times == 1))
  {
   unsigned short nTempBus;
   bcdefbus(nReservBus);
   nTempBus = nMainBus;
   nMainBus = nReservBus;
   nReservBus = nTempBus;
   bus_num = nMainBus;
   out_number();
  }
 }
 while (--times);
/*   */
 avt_ok = 1;
 err_msg = " 筮 ன⢠ 襭";
 goto fin;
 bad_statistic:
 err_msg = " 襫  ' ⨪'";
 fin:
 if (prtscr_flag)
 {
  prtscr_flag = 0;
  err_msg = " ࢠ  PrtScr";
 }
 select_window(rtwin);
 check_int();
 all_screen();
 putchar('\007');
 if (avt_ok)
  textcolor(GREEN);
 else
  textcolor(LIGHTRED);
 comment(err_msg);
 textcolor(LIGHTGRAY);
 select_window(bcwin);
 statistic_out("");
 select_window(nmainwin=rtwin);
 avt_ctrl("0");
}

int statistic_bc_rt(TMK_DATA st_base, TMK_DATA st_subadr, TMK_DATA st_data)
{
 long cnt;
// unsigned short time1;
 long ltime1;
 int k;

 select_window(bcwin);
 gotoxy(1, 11);
 textcolor(CYAN);
 printf(" ⨪.  PrtScr  室...");
 textcolor(LIGHTGRAY);
 ctrl_code = DATA_BC_RT;
 out_ctrl_code();
 base = st_base;
 out_base();
 for (k = 1; k <= 32; k++)
  buffer[k] = st_data;
 bcdefbase(st_base);
 buffer[0] = (rtadr)<<11 | RT_RECEIVE | (st_subadr<<5);
 bcputblk(0, buffer, 33);
 out_buffer();
 bcdefbase((TMK_DATA)(st_base^1));
 buffer[0] = (rtadr)<<11 | RT_RECEIVE | ((st_subadr ^ 1)<<5);
 bcputblk(0, buffer, 33);
 for (cnt = 0; cnt <= GL_COUNTER; cnt++)
 {
  if (prtscr_flag)
   cnt = GL_COUNTER;
  if (cnt < GL_COUNTER)
  {
   tmkselect(bcnum);
   int_num[bcnum] = 0;
   bcstart(st_base, DATA_BC_RT);
   st_base ^= 1;
//   time1 = get_timer();
   ltime1 = biostime(0, 0L);
  }
  else
   good_starts--;
  if (cnt > 0)
  {
   tmkselect(rtnum);
   rtdefsubaddr(RT_RECEIVE, st_subadr);
   rtgetblk(0, buffer, 32);
   if (cnt == 1)
   {
    select_window(rtwin);
    out_subadr();
    out_buffer();
    select_window(bcwin);
   }
   for (k = 0; k <= 31; k++)
    if (buffer[k] != st_data) channel_err++;
   st_subadr ^= 1;
  }
//  while (time1 - get_timer() < _5000_MCSEC)
  while (biostime(0, 0L) - ltime1 < 10)
  {
   CheckTmkEvent(fGlobalWaitEvent);
//   CheckTmkProxy(NO_WAIT_PROXY);
   if (int_num[bcnum])
    break;
  }
  if (!int_num[bcnum] && cnt < GL_COUNTER)
   to_errors++;
 }
 if (nwin == nmainwin)
  textcolor(WHITE);
 gotoxy(1, 11);
 printf("");
 textcolor(LIGHTGRAY);
 statistic_out("");
 return (bad_starts > 0 || prtscr_flag);
}

int statistic_rt_bc(TMK_DATA st_subadr, TMK_DATA st_base, TMK_DATA st_data)
{
 long cnt;
// unsigned short time1;
 long ltime1;
 int k;

 select_window(rtwin);
 for (k = 0; k <= 31; k++)
  buffer[k] = st_data;
 dir = RT_TRANSMIT;
 subadr = st_subadr;
 out_subadr();
 rtdefsubaddr(RT_TRANSMIT, st_subadr);
 rtputblk(0, buffer, 32);
 out_buffer();
 rtdefsubaddr(RT_TRANSMIT, (TMK_DATA)(st_subadr^1));
 rtputblk(0, buffer, 32);
 select_window(bcwin);
 gotoxy(1, 11);
 textcolor(CYAN);
 printf(" ⨪.  PrtScr  室...");
 textcolor(LIGHTGRAY);
 ctrl_code = DATA_RT_BC;
 out_ctrl_code();
 base = st_base;
 out_base();
 bcdefbase(st_base);
 bcputw(0, CW(rtadr, RT_TRANSMIT, st_subadr, 32));
 bcdefbase((TMK_DATA)(st_base^1));
 bcputw(0, CW(rtadr, RT_TRANSMIT, st_subadr^1, 32));
 for (cnt = 0; cnt <= GL_COUNTER; cnt++)
 {
  if (prtscr_flag)
   cnt = GL_COUNTER;
  if (cnt < GL_COUNTER)
  {
   int_num[bcnum] = 0;
   bcstart(st_base, DATA_RT_BC);
   st_base ^= 1;
//   time1 = get_timer();
   ltime1 = biostime(0, 0L);
  }
  else
   good_starts--;
  if (cnt > 0)
  {
   bcdefbase(st_base);
   bcgetblk(0, buffer, 34);
   if (cnt == 1)
    out_buffer();
   for (k = 2; k <= 33; k++)
    if (buffer[k] != st_data) channel_err++;
  }
//  while (time1 - get_timer() < _5000_MCSEC)
  while (biostime(0, 0L) - ltime1 < 10)
  {
   CheckTmkEvent(fGlobalWaitEvent);
//   CheckTmkProxy(NO_WAIT_PROXY);
   if (int_num[bcnum])
    break;
  }
  if (!int_num[bcnum] && cnt < GL_COUNTER)
   to_errors++;
 }
 if (nwin == nmainwin)
  textcolor(WHITE);
 gotoxy(1, 11);
 printf("");
 textcolor(LIGHTGRAY);
 statistic_out("");
 return (bad_starts > 0 || prtscr_flag);
}

void avt_va996(char *str)        /* প ஢ન ਥ।稪 */
{
 int i;
 long ltime1;

 if (end_ctrl(str)) return;
 if (Window[0].nMode == BC_MODE)
  bcwin = 0;
 else if (Window[1].nMode == BC_MODE)
  bcwin = 1;
 else
 {
  msg_out("    ० ");
  return;
 }
 if (Window[0].nMode == RT_MODE)
  rtwin = 0;
 else if (Window[1].nMode == RT_MODE)
  rtwin = 1;
 else
 {
  msg_out("    ० ");
  return;
 }
 bcnum = Window[bcwin].nTMK;
 rtnum = Window[rtwin].nTMK;
 avt_ctrl("1");
 avt_ok = 0;
 select_window(rtwin);
 wr_at(rtadr=0x0A); out_at();
 set_status_word("0"); /*     */
 select_window(rtwin);
 comment("⮬᪨  ਥ।稪.");
 select_window(bcwin);
 statistic_clear("");
 if (hb_mode)
 {
  subadr1 = 0x10;
  subadr2 = 0x1E;
  ci_field = 0x1F<<5;
 }
 else
 {
  subadr1 = 0x01;
  subadr2 = 0x1E;
  ci_field = 0;
 }
 ctrl_code = DATA_BC_RT; /* .  ࠢ */
                         /* ᥭ ⠭   */
 set_base("0"); buf_fill("1, 32, AAAA");
 bcputw(0, CW(rtadr, RT_RECEIVE, 0x11, 32));
 set_base("1"); buf_fill("1, 32, 0000");
 bcputw(0, CW(rtadr, RT_RECEIVE, 0x11, 32));
 set_base("2"); buf_fill("1, 32, 5555");
 bcputw(0, CW(rtadr, RT_RECEIVE, 0x11, 32));
 set_base("3"); buf_fill("1, 32, FFFF");
 bcputw(0, CW(rtadr, RT_RECEIVE, 0x11, 32));
 set_base("4"); buf_fill("1, 32, 8000");
 bcputw(0, CW(rtadr, RT_RECEIVE, 0x11, 32));
 set_base("5"); buf_fill("1, 32, 7FFF");
 bcputw(0, CW(rtadr, RT_RECEIVE, 0x11, 32));
 ltime1=biostime(0, 0L);
 prtscr_flag = 0;
 while ((biostime(0, 0L)-ltime1)<18000L && !prtscr_flag && bad_starts<100L)
 {
  for (i=0;i<GL_COUNTER && !prtscr_flag;)
  {
   for (base=0; base<=5; base++)
   {
    int_num[bcnum] = 0;
    bcstart(base, ctrl_code);
    while (!int_num[bcnum] && !prtscr_flag)
     CheckTmkEvent(fGlobalWaitEvent);
//     CheckTmkProxy(NO_WAIT_PROXY);
    i++;
   }
  }
  statistic_out("");
 }
 set_base("0");
 out_ctrl_code();
 out_base();
 bc_out_ram(base);
/*   */
 if (bad_starts>=100L)
 {
  err_msg = " ਥ।稪  襫";
 }
 else if (prtscr_flag)
 {
  err_msg = " ࢠ  'PrtScr'";
 }
 else
 {
  avt_ok = 1;
  err_msg = " ਥ।稪 襭";
 }
 check_int();
 select_window(bcwin);
 all_screen();
 select_window(rtwin);
 putchar('\007');
 if (avt_ok)
  textcolor(GREEN);
 else
  textcolor(LIGHTRED);
 comment(err_msg);
 textcolor(LIGHTGRAY);
 select_window(nmainwin=bcwin);
 statistic_out("");
 avt_ctrl("0");
}

void avt_flags(char *str)            /* প ஢ન 䫠  */
{
 TMK_DATA page;
 TMK_DATA tsubadr;

 if (end_ctrl(str)) return;
 if (Window[0].nMode == RT_MODE)
  rtwin = 0;
 else if (Window[1].nMode == RT_MODE)
  rtwin = 1;
 else
 {
  msg_out("    ० ");
  return;
 }
 if (Window[0].nMode == BC_MODE)
  bcwin = 0;
 else if (Window[1].nMode == BC_MODE)
  bcwin = 1;
 else
 {
  msg_out("    ० ");
  return;
 }
 bcnum = Window[bcwin].nTMK;
 rtnum = Window[rtwin].nTMK;
 statistic_clear("");
 avt_ctrl("1");
 avt_ok = 0;
 select_window(rtwin);
 rtreset();
 rt_clear_ram();
 comment("⮬᪨  䫠 ० 筮 ன⢠.");
 wr_at(rtadr=0x0A); out_at();
 set_status_word("0"); /*     */
 rtdefmode((TMK_DATA)(rtgetmode()|RT_FLAG_MODE));
 rtdefpage(page=0);
 if (hb_mode)
 {
  subadr1 = 0x10;
  subadr2 = 0x1E;
  ci_field = CI_MASK;
 }
 else
 {
  subadr1 = 0x01;
  subadr2 = 0x1E;
  ci_field = 0;
 }
 for (subadr = subadr1; subadr <= subadr2; subadr++)
 {
  rtdefsubaddr(RT_TRANSMIT, subadr);
  buffer[0] = (page<<14) | (subadr<<8) | (page<<6) | subadr | 0x2020;
  rtputblk(0, buffer, 1);
  rtsetflag();
 }
 select_window(bcwin);
 bcreset();
 bc_clear_ram();
 bcdefbase(base=0);
 for (subadr = subadr1; subadr <= subadr2; subadr++)
 {
  ctrl_code = DATA_RT_BC;
  bcputw(0, CW(rtadr, RT_TRANSMIT, subadr, 1));
  start_1("");
  if (int_num[bcnum] != 1)
  {
   err_msg = "->: 諠 ।    ⠭ 䫠";
   goto fin;
  }
  select_window(rtwin);
  for (tsubadr = subadr1; tsubadr < subadr; tsubadr++)
  {
   if ((rtgetflag(RT_TRANSMIT, tsubadr)&RT_FLAG) != 0)
   {
    err_msg = "->:⠭ 䫠  ࠭ । ";
    goto fin;
   }
  }
  if ((rtgetflag(RT_TRANSMIT, subadr)&RT_FLAG) != 0)
  {
   err_msg = "->: ᨫ 䫠  । ";
   goto fin;
  }
  for (tsubadr = subadr+1; tsubadr < subadr2; tsubadr++)
  {
   if ((rtgetflag(RT_TRANSMIT, tsubadr)&RT_FLAG) == 0)
   {
    err_msg = "->:ᨫ 䫠    । ";
    goto fin;
   }
  }
  select_window(bcwin);
 }
 bcdefbase(base=0);
 for(subadr = subadr1; subadr <= subadr2; subadr++)
 {
  ctrl_code = DATA_RT_BC;
  bcputw(0, CW(rtadr, RT_TRANSMIT, subadr, 1));
  start_1("");
  if (int_num[bcnum] != 2 || bc_sw != (S_TO_MASK|S_IB_MASK))
  {
   err_msg = "->: 襫  ।    襭 䫠";
   goto fin;
  }
  select_window(rtwin);
  for (tsubadr = subadr1; tsubadr <= subadr2; tsubadr++)
  {
   if ((rtgetflag(RT_TRANSMIT, tsubadr)&RT_FLAG) != 0)
   {
    err_msg = "->:⠭ 䫠  ࠭ । ";
    goto fin;
   }
  }
  select_window(bcwin);
 }
 select_window(rtwin);
 rt_clear_ram();
 for (subadr = subadr1; subadr <= subadr2; subadr++)
 {
  rtdefsubaddr(RT_RECEIVE, subadr);
  rtclrflag();
 }
 select_window(bcwin);
 bcdefbase(base=1);
 for (subadr = subadr1; subadr <= subadr2; subadr++)
 {
  ctrl_code = DATA_BC_RT;
  buffer[0] = (rtadr<<11) | RT_RECEIVE | (subadr<<5) | 1;
  buffer[1] = (page<<14) | (subadr<<8) | (page<<6) | subadr;
  bcputblk(0, buffer, 2);
  start_1("");
  if (int_num[bcnum] != 1)
  {
   err_msg = "->: 襫 ਥ    襭 䫠";
   goto fin;
  }
  select_window(rtwin);
  for (tsubadr = subadr1; tsubadr < subadr; tsubadr++)
  {
   if ((rtgetflag(RT_RECEIVE, tsubadr)&RT_FLAG) == 0)
   {
    err_msg = "->:ᨫ 䫠  ࠭ ਭ⮣ ";
    goto fin;
   }
  }
  if ((rtgetflag(RT_RECEIVE, subadr)&RT_FLAG) == 0)
  {
   err_msg = "->: ⠭ 䫠  ਭ⮣ ";
   goto fin;
  }
  if (rtgetw(0) != ((page<<14) | (subadr<<8) | (page<<6) | subadr))
  {
   err_msg = "->:   ਥ  ";
   goto fin;
  }
  for (tsubadr = subadr+1; tsubadr < subadr2; tsubadr++)
  {
   if ((rtgetflag(RT_RECEIVE, tsubadr)&RT_FLAG) != 0)
   {
    err_msg = "->:⠭ 䫠    ਭ⮣ ";
    goto fin;
   }
  }
  select_window(bcwin);
 }
 for (subadr = subadr1; subadr <= subadr2; subadr++)
 {
  ctrl_code = DATA_BC_RT;
  buffer[0] = (rtadr<<11) | RT_RECEIVE | (subadr<<5) | 1;
  buffer[1] = 0xFFFF;
  bcputblk(0, buffer, 2);
  start_1("");
  if (int_num[bcnum] != 2 || bc_sw != S_IB_MASK)
  {
   err_msg = "->: 襫  ਥ    ⠭ 䫠";
   goto fin;
  }
  select_window(rtwin);
  rtdefsubaddr(RT_RECEIVE, subadr);
  if (rtgetw(0) == 0xFFFF)
  {
   err_msg = "->: ਥ    ⠭ 䫠 ᠫ ";
   goto fin;
  }
  for (tsubadr = subadr1; tsubadr <= subadr2; tsubadr++)
  {
   if ((rtgetflag(RT_RECEIVE, tsubadr)&RT_FLAG) == 0)
   {
    err_msg = "->:ᨫ 䫠  ࠭ ਭ⮣ ";
    goto fin;
   }
  }
  select_window(bcwin);
 }
/*   */
 avt_ok = 1;
 err_msg = " 䫠 ० 筮 ன⢠ 襭";
 fin:
/*
 if (prtscr_flag)
 {
  prtscr_flag = 0;
  err_msg = " ࢠ  PrtScr";
 }
*/
 select_window(rtwin);
 rtdefmode((TMK_DATA)(rtgetmode()&(~RT_FLAG_MODE)));
 check_int();
 all_screen();
 putchar('\007');
 if (avt_ok)
  textcolor(GREEN);
 else
  textcolor(LIGHTRED);
 comment(err_msg);
 textcolor(LIGHTGRAY);
 select_window(bcwin);
 statistic_out("");
 select_window(nmainwin=rtwin);
 avt_ctrl("0");
}

int cmp_ram_buf(int offset, int voffset, int size)
/* ࠢ   ram_window: 0 -  , 1 - 訡
offset - ᬥ饭, size - ࠧ ࠢ ᨢ */
{
 int i;

 if (voffset >= 0)
 {
  switch (tmkgetmode())
  {
  case BC_MODE:
   bcgetblk(0, vbuffer, (TMK_DATA)(size+voffset));
   break;
  case RT_MODE:
   rtgetblk(0, vbuffer, (TMK_DATA)(size+voffset));
  }
 }
 else
  voffset = 0;
 for (i=0; i < size; i++)
  if (buffer[i+offset]!=vbuffer[i+voffset]) return 1;
 return 0;
}

void avt_ctrl(char *str)                /* ࠢ 뢮  ࠭ */
{
 unsigned short a;

 if (sscanf(str, "%u", &a)!=1)
 {
  msg_out(inp_err);
  return;
 }
 if (a!=0 && a!=1)
 {
  msg_out("୮ 祭 ६");
  return;
 }
 avtomat=a;
}

#ifdef STEND
void init_lpt()
/*
       ᫥ ஢ ⮢  ⠡  BIOS .
*/
{
 lpt_data_port=peek(0x0040, 8+(lpt_num-1)*2); /*  ⮢ LPT */
 lpt_status_port=lpt_data_port+1;
 lpt_ctrl_port=lpt_data_port+2;
}

void set_lpt_data(unsigned short char data)
{
 outportb(lpt_data_port, data);
}
#endif

void buf_fill(char *str)   /*   ⠭⮩ */
{
 unsigned short start, end, len, constant;

 while (*str == '\t' || *str == ' ') str++;
 if (sscanf(str, "%u", &start) != 1)
 {
  msg_out(mark_err); return;
 }
 if (start > buf_size-1)
 {
  msg_out(mark_err); return;
 }
 while (*str != ' ' && *str != ', ') str++;
 while (*str == ' ' || *str == ', ') str++;
 if (sscanf(str, "%u", &end) != 1)
 {
  msg_out(mark_err); return;
 }
 if (end < start || end > buf_size-1)
 {
  msg_out(mark_err); return;
 }
 while (*str != ' ' && *str != ', ') str++;
 while (*str == ' ' || *str == ', ') str++;
 if (sscanf(str, "%x", &constant) != 1)
 {
  msg_out(const_err); return;
 }
 len = end - start + 1;
 while (end >= start) buffer[end--]=constant;
 out_buffer();
 switch (Window[nwin].nMode)
 {
 case BC_MODE:
  bcdefbase(base);
  bcputblk(start, buffer+start, len);
  break;
 case RT_MODE:
  rtdefsubaddr(dir, subadr);
  rtputblk(start, buffer+start, len);
 }
}

void buf_clear(char *str)  /* ⪠  */
{
 int i;

 if (end_ctrl(str)) return;
 for (i=64; i-- != 0; buffer[i]=0);
 buf_mark=0;
 in_ed_word=3;
 out_buffer();
 switch(Window[nwin].nMode)
 {
 case BC_MODE:
  bcdefbase(base);
  bcputblk(0, buffer, 36);
  break;
 case RT_MODE:
  rtdefsubaddr(dir, subadr);
  rtputblk(0, buffer, 32);
 }
}

int end_ctrl(char *str)
  /* ஫  ப(   㬥⮢):
     1 -  ப  - 饥 , 
     0 -  ப                  */
{
 while (*str == '\t' || *str == ' ') str++;
 if (*str)
 {
  msg_out(undef_cmd);
  return 1;
 }
 else
  return 0;
}

void clear_dump()
{
 int y, maxy;

 maxy = (avtomat) ? BDUMP_Y + 3 : BDUMP_Y + 4;
 for (y = BDUMP_Y - 1; y <= maxy; y++)
 {
  gotoxy(1, y);
  clreol();
 }
}

void buf_edit(char *str)                   /* ।஢ ୮  */
{
 static int in_word=3;    /*  ⥪饩 ࠤ  ।஢ */
 static int edit_mode=0;  /* ⥪騩 ० ।஢: 0 - HEX, 1 - BIN */
 static int bit_num=15;   /* ⥪騩   ।஢ */
 unsigned short key, tetrada, bit;
 int tmkmode;

 switch (tmkmode = Window[nwin].nMode)
 {
 case BC_MODE:
  bc_out_ram(base);
  break;
 case RT_MODE:
  rt_out_ram(dir, subadr);
 }
 while (*str == '\t' || *str == ' ') str++;
 if (mark_set(str, &buf_mark)) return;
 do
 {
  if (edit_mode)
  {
   bin_unpack(62, BDUMP_Y, buf_mark, buffer[buf_mark]);
   gotoxy(BDUMP_X-1+5*(buf_mark%DUMP_WIDE+1)-3, BDUMP_Y+buf_mark/DUMP_WIDE);
   printf("%04X", buffer[buf_mark]);
   gotoxy(61+(16-bit_num), BDUMP_Y+1);
  }
  else
  {
   bin_unpack(62, BDUMP_Y, buf_mark, buffer[buf_mark]);
   gotoxy(BDUMP_X-1+5*(buf_mark%DUMP_WIDE+1)-in_word, BDUMP_Y+buf_mark/DUMP_WIDE);
  }
  while (kbhit() == 0)
   WaitForMultipleObjects(nWaitEvents+1, ahWaitEvents, FALSE, 0);
  key=bioskey();
  if ((key & 0x00FF) && key != GPLUSW)
  {
   switch (key = toupper(key&0x00FF))       /*   ᨬ ࠢ */
   {
   case 'Q':
   case ESCAPE:
                  key='Q';
                  break;
   case TAB:
                  if (edit_mode)
                  {
                   edit_mode=0;
                   in_word=bit_num/4;
                  }
                  else
                  {
                   edit_mode=1;
                   bit_num=in_word*4+3;
                  }
                  break;
   case CR:
   case LF:
                  edit_mode=0;
                  if (buf_mark != DUMP_SIZE-1)
                   ++buf_mark;
                  else
                   buf_mark=0;
                  break;
                 case ' ':
                  if (edit_mode) break;
                  if (in_word == 0)
                  {
                   if (buf_mark != DUMP_SIZE-1)
                   {
                    in_word=3;
                    buf_mark++;
                   }
                  }
                  else
                   in_word--;
                  break;
   case BACKSPACE:
                  if (edit_mode) break;
                  if (in_word == 3)
                  {
                   if (buf_mark != 0)
                   {
                    in_word=0;
                    buf_mark--;
                   }
                  }
                  else
                   in_word++;
                  break;
   default:
                  if (edit_mode)
                  {
                   if (key != '0' && key != '1') break;
                   bit=key-'0';
                   buffer[buf_mark]&=~(0x0001<<bit_num);
                   buffer[buf_mark]|=(bit<<bit_num);
                   if (bit_num != 0) bit_num--;
                   break;
                  }
                  if (key >= '0' && key <= '9')
                   tetrada=key-'0';
                  else if (key >= 'A' && key <= 'F')
                   tetrada=key-'A'+10;
                  else
                   break;
                  putchar(key);
                  buffer[buf_mark]&=~(0x000F<<in_word*4);
                  buffer[buf_mark]|=(tetrada<<in_word*4);
                  if (in_word == 0)
                  {
                   if (buf_mark != DUMP_SIZE-1)
                   {
                    in_word=3;
                    buf_mark++;
                   }
                  }
                  else
                   in_word--;
                  break;
                 }
  }
  else
  {
   switch (key)                            /* 㭪樮  */
   {
   case F01:
              clear_dump();
              gotoxy(1, BDUMP_Y);
              printf("  \x1E      -  ࠤ ࠢ, \x11--(BACKSPACE) -  ࠤ , ");
              gotoxy(1, BDUMP_Y+1);
              printf("\x11   \x10 - ६饭  ᫮, HOME -  砫 , END -   , ");
              gotoxy(1, BDUMP_Y+2);
              printf("  \x1F     TAB - HEX/BIN ०, Q(F10) -  ।஢.");
              gotoxy(1, BDUMP_Y+3);
              switch (tmkmode)
              {
              case BC_MODE:
               printf("        PGUP, PGDN -  .");
               break;
              case RT_MODE:
               printf("        PGUP, PGDN -  ,   - ਥ/।.");
              }
              
              while (!kbhit())
               WaitForMultipleObjects(nWaitEvents+1, ahWaitEvents, FALSE, 0);
              bioskey();
              clear_dump();
              out_buffer();
              break;
   case LEFT:
              if (edit_mode)
              {
               if (bit_num != 15)
                bit_num++;
               break;
              }
              if (buf_mark != 0) --buf_mark;
              else buf_mark=DUMP_SIZE-1;
              in_word = 3;
              break;
   case RIGHT:
              if (edit_mode)
              {
               if (bit_num != 0) bit_num--;
               break;
              }
              if (buf_mark != DUMP_SIZE-1) ++buf_mark;
              else buf_mark=0;
              in_word = 3;
              break;
   case UP:
              if (edit_mode)
              {
               if (buf_mark != 0) --buf_mark;
               else buf_mark=DUMP_SIZE-1;
               break;
              }
              if (buf_mark-DUMP_WIDE >= 0) buf_mark-=DUMP_WIDE;
              else
              {
               buf_mark+=(DUMP_WIDE*(DUMP_STRINGS-1));
               if (buf_mark > DUMP_SIZE-1) buf_mark-=DUMP_WIDE;
              }
              in_word = 3;
              break;
   case DOWN:
              if (edit_mode)
              {
               if (buf_mark != DUMP_SIZE-1) ++buf_mark;
               else buf_mark=0;
               break;
              }
              if (buf_mark+DUMP_WIDE <= DUMP_SIZE-1) buf_mark+=DUMP_WIDE;
              else
              {
               buf_mark-=(DUMP_WIDE*(DUMP_STRINGS-1));
               if (buf_mark < 0) buf_mark+=DUMP_WIDE;
              }
              in_word = 3;
              break;
   case HOME:
              if (edit_mode)
              {
               bit_num=15;
               break;
              }
              buf_mark=0;
              in_word = 3;
              break;
   case END:
              if (edit_mode)
              {
               bit_num=0;
               break;
              }
              buf_mark=DUMP_SIZE-1;
              in_word = 3;
              break;
   case GPLUS:
              if (tmkmode == RT_MODE)
              {
               rtputblk(0, buffer, 32);
               dir = (dir == RT_TRANSMIT) ? RT_RECEIVE : RT_TRANSMIT;
               rtdefsubaddr(dir, subadr);
               rtgetblk(0, buffer, 32);
               out_subadr();
               out_buffer();
              }
              break;
   case PGUP:
              switch (tmkmode)
              {
              case BC_MODE:
               if (base > 0)
               {
                bcputblk(0, buffer, 36);
                bcdefbase(--base);
                bcgetblk(0, buffer, 36);
                out_base();
                out_buffer();
               }
               break;
              case RT_MODE:
               if (subadr > 0)
               {
                rtputblk(0, buffer, 32);
                rtdefsubaddr(dir, --subadr);
                rtgetblk(0, buffer, 32);
                out_subadr();
                out_buffer();
               }
              }
              in_word = 3;
              break;
   case PGDN:
              switch (tmkmode)
              {
              case BC_MODE:
               if (base < bcgetmaxbase())
               {
                bcputblk(0, buffer, 36);
                bcdefbase(++base);
                bcgetblk(0, buffer, 36);
                out_base();
                out_buffer();
               }
               break;
              case RT_MODE:
               if (subadr < 31)
               {
                rtputblk(0, buffer, 32);
                rtdefsubaddr(dir, ++subadr);
                rtgetblk(0, buffer, 32);
                out_subadr();
                out_buffer();
               }
              }
              in_word = 3;
              break;
   case F10:
              key='Q';
              break;
   }
   continue;
  }
 }
 while (key != 'Q');
 switch (tmkmode)
 {
 case BC_MODE:
  bcputblk(0, buffer, 36);
  break;
 case RT_MODE:
  rtputblk(0, buffer, 32);
 }
}

int mark_set(char *str, int *mark)
/*   ⥪饣 ᫮  ।஢
1 - 訡, 0 -   浪
*/
{
 unsigned short i, constant;

 if (*str == '\0') return 0;
 if ((sscanf(str, "%u", &i)) != 1)
 {
  msg_out(inp_err);
  return 1;
 }
 if (i > DUMP_SIZE-1)
 {
  msg_out(mark_err);
  return 1;
 }
 *mark=i;
 while (*str != ' ' && *str != ', ' && *str != '\0') str++;
 if (!*str) return 0;
 while (*str == ' ' || *str == ', ') str++;
 if (sscanf(str, "%x", &constant) != 1) { msg_out(const_err); return 1; }
 buffer[*(mark)]=constant;
 out_buffer();
 return 1;
}


void out_func_str()   /* 뢮 ᪠  祭 㭪樮  */
{
 int i;

 static char *bc_func_str[10]={  "",  /* F01 */
                                 "   ",  /* F02 */
                                 ".",  /* F03 */
                                 "  ",  /* F04 */
                                 "      ",  /* F05 */
                                 " ",  /* F06 */
                                 "  ",  /* F07 */
                                 " ",  /* F08 */
                                 "  ",  /* F09 */
                                 "."     /* F10 */
                              };
 static char *rt_func_str[10]={  "",  /* F01 */
                                 "   ",  /* F02 */
                                 ".",  /* F03 */
                                 "  ",  /* F04 */
                                 "      ",  /* F05 */
                                 "   ",  /* F06 */
                                 "   ",  /* F07 */
                                 " ",  /* F08 */
                                 "  ",  /* F09 */
                                 "."     /* F10 */
                              };

 gotoxy(1, 25);
 for (i=1; i <= 10; i++)
 {
  printf("%u", i);
  textbackground(LIGHTGRAY);
  textcolor(BLACK);
  switch (Window[nwin].nMode)
  {
  case BC_MODE: printf("%s", bc_func_str[i-1]);
                break;
  case RT_MODE: printf("%s", rt_func_str[i-1]);
                break;
  }
  textbackground(BLACK);
  textcolor(LIGHTGRAY);
  putchar(' ');
 }
}

void hor_line(int maxi)
{
 register i;
 for (i = 1; i <= maxi; i++)
  putchar(chH);
 
}

void all_screen()                                   /* 뢮  ࠭ */
{
 int savenwin, nDX, nDY, i;

 savenwin = nwin;
 clrscr();
 window(1, 1, 80, 25);
 out_func_str();
 for (nwin = 0; nwin <= nMaxWin; nwin++)
 {
  if (!Window[nwin].fVisible)
   continue;
  select_window(nwin);
  if (nwin == savenwin)
  {
   textcolor(WHITE);
   chLU = '';
   chRU = '';
   chLD = '';
   chRD = '';
   chV = '';
   chH = '';
  }
  else
  {
   textcolor(LIGHTGRAY);
   chLU = '';
   chRU = '';
   chLD = '';
   chRD = '';
   chV = '';
   chH = '';
  }
  nDX = Window[nwin].nDX;
  nDY = Window[nwin].nDY;
  window(Window[nwin].nX, Window[nwin].nY, 
          Window[nwin].nX + nDX - 1, 
          Window[nwin].nY + nDY - 1);
  gotoxy(1, 1);
  putchar(chLU);
  hor_line(nDX - 2);
  putchar(chRU);
  for (i = 2; i < nDY; i++)
  {
   gotoxy(1, i);
   putchar(chV);
   gotoxy(nDX, i);
   putchar(chV);
  }
  gotoxy(1, nDY);
  putchar(chLD);
  hor_line(nDX - 2);
  putchar(chRD);
  window(Window[nwin].nX + 1, Window[nwin].nY, 
          Window[nwin].nX + nDX - 2, 
          Window[nwin].nY + nDY - 1);
  textcolor(LIGHTGRAY);
  out_mode();
  out_type();
  out_fname();
  out_inn();
  switch(Window[nwin].nMode)
  {
  case BC_MODE:
   out_count();
   out_number();
   out_base();
   out_pause();
   out_ctrl_code();
   bc_out_sw();
   bc_out_ram(base);
   break;
  case RT_MODE:
   out_subadr();
   out_at();
   out_page();
   out_rt_mode();
   out_status_word();
   rt_out_sw();
   rt_out_ram(dir, subadr);
   break;
  }
 }
 nwin = savenwin;
 select_window(nwin);
 window(Window[nwin].nX + 1, Window[nwin].nY, 
         Window[nwin].nX + Window[nwin].nDX - 2, 
         Window[nwin].nY + Window[nwin].nDY - 1);
}

void bc_out_ram(TMK_DATA base)
  /* ⥭  뢮    */
{
 bcdefbase(base);
 bcgetblk(0, buffer, 36);
 out_buffer();
}

void rt_out_ram(TMK_DATA dir, TMK_DATA subadr)
  /* ⥭  뢮    */
{
 if (fLock)
   rtlock(dir, subadr);
 else
   rtdefsubaddr(dir, subadr);
 rtgetblk(0, buffer, 32);
 out_buffer();
}


void out_buffer()      /* 뢮   */
{
 gotoxy(1, BDUMP_Y-1);
 printf("     ");
 gotoxy(BDUMP_X, BDUMP_Y-1);
 out_dump(buffer);
 bin_unpack(62, BDUMP_Y, buf_mark, buffer[buf_mark]);
}

void bin_unpack(int x, int y, int adr, int data)
/*
뢮   ᮤন(筠 ଠ)
x, y -  ᯮ
*/
{
 gotoxy(x, y);
 printf("%03Xh:%02u: %04X", adr, adr, data);
 gotoxy(x, y+1);
 out_bin(data, 16);
 gotoxy(x, y+2);
 printf("FEDCBA9876543210");
}

void bc_out_sw()                    /* 뢮 ᫮ ﭨ (bc_sw) */
{
 gotoxy(1, 4);
 printf(" ﭨ: ");
 if (int_num[Window[nwin].nTMK])
  out_bin(bc_sw, 7);
 else
  printf("XXXXXXX");
 
}

void out_inn()                        /* 뢮  뢠 (int_num) */
{
 gotoxy(41, 4);
 printf(" 뢠: ");
 if (int_num[Window[nwin].nTMK])
  printf("%u", int_num[Window[nwin].nTMK]);
 else
  putchar('X');
 
}

void out_mode()     /* 뢮 ⥪饣 ० (mode) */
{
 gotoxy(2, 1);
 if (nwin == nmainwin)
  textcolor(WHITE);
 else
  textcolor(LIGHTGRAY);
 printf("%d%c", Window[nwin].nTMK, chH);
 if (Window[nwin].nMode == BC_MODE)
  printf(" ");
 else if (Window[nwin].nMode == RT_MODE)
  printf(" ");
 textcolor(LIGHTGRAY);
 
}

void out_port(unsigned short wPort)
{
 if (wPort && wPort != 0xFFFF)
 {
  printf("%03Xh%c", wPort, chH);
  
 }
}

void out_irq(unsigned short wIrq)
{
 if (wIrq && ~wIrq && wIrq != 255 && wIrq != 65535)
 {
  printf("Irq %d%c", wIrq, chH);
  
 }
}

/*
void out_iodelay()
{
 printf("IOD%3d%c", tmkiodelay(GET_IO_DELAY), chH);
}
*/

void out_type()
{
 int nTMK = Window[nwin].nTMK;
 gotoxy(26, 1);
 if (nwin == nmainwin)
  textcolor(WHITE);
 else
  textcolor(LIGHTGRAY);
 printf("%s%c", aTmkConfig[nTMK].szName, chH);
 out_port(aTmkConfig[nTMK].wPorts1);
 out_port(aTmkConfig[nTMK].wPorts2);
 out_irq(aTmkConfig[nTMK].wIrq1);
 out_irq(aTmkConfig[nTMK].wIrq2);
// out_iodelay();
 textcolor(LIGHTGRAY);
}

void out_count()   /* 뢮 祭 稪 ७ */
{
 gotoxy(52, 2);
 printf(": %010lu", cmd_count);
}

void out_fname()                      /* 뢮  ᫥ 䠩  */
{
 gotoxy(61, 1);
 printf(":");
 if (nwin == nmainwin)
 {
  textcolor(WHITE);
  printf("");
  textcolor(LIGHTGRAY);
 }
 else
  printf("");
 
 if (*Window[nwin].data_fname != '\0')
 {
  gotoxy(66, 1);
  printf("%s", Window[nwin].data_fname);
 }
}

void out_pause()               /* 뢮 祭 ६  뢠 */
{
 gotoxy(32, 2);
 printf("㧠: %5u ", opause);
}

void out_base()           /* 뢮 祭 , ᯮ㥬  ᪥ */
{
 gotoxy(20, 2);
 printf(": %03X", base);
}

void out_number()                          /* 뢮   (bus_num) */
{
 gotoxy(1, 2);
 printf(": %01u", bus_num+1);
}

void out_ctrl_code()                    /* 뢮  ࠢ (ctrl_code) */
{
 gotoxy(1, 3);
 printf(" ࠢ:                                   ");
 gotoxy(17, 3);
 if (correct_cc(ctrl_code))
  out_bin(ctrl_code, CC_SIZE);
 else
 {
  printf("XXXX ( ।)");
  return;
 }
 switch (ctrl_code & 0x0007)
 {
 case 0x0: printf(" (->");
           break;
 case 0x1: printf(" (->");
           break;
 case 0x2: printf(" (->");
           break;
 case 0x3: printf(" (->");
           break;
 case 0x4: printf(" (+->");
           break;
 case 0x5: printf(" (->+");
           break;
 }
 if (ctrl_code & 0x0008)
  printf(", 㯯 뫪)");
 else
  printf(")");
 
}

int correct_cc(int ctrl_code)
/*
஢ઠ ४⭮  ࠢ:
0 - 騩, 1 - ଠ.
*/
{
 return ccs[ctrl_code&=0x000F];
}

void out_page()                               /* 뢮  ࠭  */
{
 gotoxy(50, 2);
 printf("࠭   :%2u", rtgetpagebus());
 gotoxy(50, 3);
 printf("࠭ :%2u", rtgetpagepc());
 
}

void out_rt_mode()
{
 gotoxy(70, 2);
 if (hb_mode)
  printf("HBIT");
 else
  printf("    ");
 
}

void out_at()                                   /* 뢮  ନ */
{
 gotoxy(27, 2);
 if (Window[nwin].at_avail)
  terminal_adr = rtgetaddress();
#ifndef STEND
 else
 {
  printf(" : ");
  return;
 }
#endif
 printf(" : %02u ", terminal_adr);
 putchar('(');
 out_bin(terminal_adr, 5);
 putchar(')');
 
}

void rt_out_sw()                          /* 뢮 ᫮ ﭨ (rt_sw) */
{
 gotoxy(1, 4);
 printf(" ﭨ: ");
 out_bin(rt_sw, 16);
}

void out_subadr()                 /* 뢮 祭 , ᯮ㥬  ᪥ */
{
 gotoxy(1, 2);
 printf(": %02X", subadr);
 if (dir == RT_TRANSMIT)
  printf(" (।)");
 else
  printf(" (ਥ)   ");
 
}

void out_status_word()                  /* 뢮 ⮢  (status_word) */
{
  unsigned short status_word;

  status_word = rtgetanswbits();
  gotoxy(1, 3);
  printf("⢥⭮ ᫮: ");
  out_bin(status_word, SW_SIZE);
  if (status_word&DNBA)
   printf(" (DN ");
  else
   printf(" (-- ");
  if (status_word&RTFL)
   printf("TF ");
  else
   printf("-- ");
  if (status_word&SSFL)
   printf("SF ");
  else
   printf("-- ");
  if (status_word&BUSY)
   printf("BS ");
  else
   printf("-- ");
  if (status_word&SREQ)
   printf("SR)");
  else
   printf("--)");
  
}

void out_dump(unsigned short *data)
/*
뢮 ᫮ :
adr - 祭  ᯮ㥬  뢮
data - 㪠⥫  ᫮,  ண ந室 뢮 
*/
{
 int i;                 /* 稪 */
 int offset;            /* ⥪饥 ᬥ饭  ᨢ . data */
 int dump_y;

 gotoxy(BDUMP_X, BDUMP_Y-1);
 for (i=0; i != DUMP_WIDE; printf("  %01X  ", i++));
 dump_y = BDUMP_Y;
 for (offset=0; offset != DUMP_SIZE;)
 {
  gotoxy(1, dump_y);
  printf("     %02u: ", offset);
//  gotoxy(BDUMP_X, dump_y);
  for (i=0; (i != DUMP_WIDE) && (offset != DUMP_SIZE); i++, offset++)
   printf(" %04X", *(data+offset));
  dump_y++;
 }
 
}

void out_bin(int data, int num_digits)
/*
뢮  筮 ଥ:
data - 뢮 祭
num_digits - ᫮ 뢮 , 稭 ࠢ
*/
{
 char string[16];
 int mask;
 int count;

 for (count=0, mask=1; count != 16; count++, mask<<= 1)
  string[count]=(data&mask)?'1':'0';
 if (fields && num_digits == 16)
 {
  count=num_digits;    /* 뢮 ᫮  뤥  */
  textcolor(CYAN);
  for (; count != 11; putchar(string[--count]));
  textcolor(LIGHTRED);
  putchar(string[--count]);
  textcolor(YELLOW);
  for (; count != 5; putchar(string[--count]));
  textcolor(GREEN);
  for (; count != 0; putchar(string[--count]));
  textcolor(LIGHTGRAY);
 }
 else       /* 뢮  뤥  */
 {
  for (count=num_digits; --count >= 0; putchar(string[count]));
 }
}

void cmds_open(char *str)   /* ⨥  䠩 */
{
 while (*str == ' ' || *str == '\t') str++;
 if (enter_mode)             /* ᫨  䠩 뢠   */
 {
  fclose(cmd_file);
  enter_mode=0;
 }
 if ((cmd_file=fopen(str, "rt")) == NULL)
 {
  msg_out(open_err);
  return;
 }
 enter_mode=1;
}

void bc_buf_rd(char *str) /* ⥭  ࠢ    䠩 */
{
 int ch;
 char *ptr;

 int ctrl_code2, offset;
 static unsigned short buffer2[BC_BUF_SIZE];

 while (*str == ' ' || *str == '\t') str++;
 if ((in_file=fopen(str, "rt")) == NULL)
 {
  msg_out(open_err);
  return;
 }
 while (*str != '\0') str++;
 str--;
 for (; *str != ':' && *str != '\\' && *str != ' ' && *str != '\t'; str--);
 str++;
 strcpy(Window[nwin].data_fname, str);
 out_fname();
 fgets(buf_str, 80, in_file); /* ய  ப */
                              /* ⥭  ࠢ  䠩 */
 fgets(buf_str, 80, in_file); /* ய ப ᪠ */
 if ((fgets(buf_str, 80, in_file)) == NULL)
 {
  msg_out(format_err);
  return;
 }
 str=buf_str;
 while (*str == '\t' || *str == ' ') str++;
 ptr=str;
 while ((ch=*(ptr++)) != ' ')
 {
  if (ch != '0' && ch != '1')
  {
   msg_out(bad_ctrl_code);
   return;
  }
 }
 --ptr;
 if (ptr-str > CC_SIZE)
 {
  msg_out(bad_ctrl_code);
  return;
 }
 ptr=str;
 for (ctrl_code2=0; *ptr != ' '; ptr++)
 {
  ctrl_code2<<= 1;
  if (*ptr == '1') ctrl_code2++;
 }
 if (!correct_cc(ctrl_code2))
 {
  sprintf(cc_no_def, "  ࠢ");
  msg_out(cc_no_def);
  return;
 }
                              /* ⥭    䠩 */
 fgets(buf_str, 80, in_file); /* ய ப ᪠ */
 offset=0;
 while (offset != BC_DUMP_SIZE)
 {
  if (fscanf(in_file, "%x ", &buffer2[offset]) != 1)
  {
   msg_out(format_err);
   return;
  }
  if ((++offset%DUMP_WIDE) == 0)
   while ((ch=fgetc(in_file)) != '\n')
    if (ch == EOF)
    {
     msg_out(format_err);
     return;
    }
 }
 ctrl_code=ctrl_code2;
 out_ctrl_code();
 for (offset=0; offset != BC_DUMP_SIZE; offset++)
  buffer[offset]=buffer2[offset];
 bcputblk(0, buffer, 36);
 out_buffer();
 fclose(in_file);
}

void bc_buf_wr(char *str)   /*     ࠢ  䠩 */
{

 int i, offset;

 while (*str == ' ' || *str == '\t') str++;
 if ((out_file=fopen(str, "wt")) == NULL)
 {
  msg_out(cr_err);
  return;
 }
 strcpy(Window[nwin].data_fname, str);
 out_fname();
 {
  int mask;
  int count;
  fprintf(out_file, "\n");
  fprintf(out_file, " ࠢ:\n");
  if (correct_cc(ctrl_code))
   for (count=0, mask=8; count != 4; count++, mask>>= 1)
    fprintf(out_file, "%c", ((ctrl_code&mask)?'1':'0'));
  else
  {
   fprintf(out_file, "XXXX ( ।)\n");
   goto out_data;
  }
  switch (ctrl_code & 0x0007)
  {
  case 0x0: fprintf(out_file, " (->");
            break;
  case 0x1: fprintf(out_file, " (->");
            break;
  case 0x2: fprintf(out_file, " (->");
            break;
  case 0x3: fprintf(out_file, " (->");
            break;
  case 0x4: fprintf(out_file, " (+->");
            break;
  case 0x5: fprintf(out_file, " (->+");
            break;
  }
  if (ctrl_code & 0x0008)
   fprintf(out_file, ", 㯯 뫪)\n");
   else fprintf(out_file, ")\n");
 }
 out_data:;
 fprintf(out_file, ":\n");
 for (offset=0; offset < BC_DUMP_SIZE;)
  {
    for (i=0; i < DUMP_WIDE; i++, ++offset)
      if (offset < BC_DUMP_SIZE)
        fprintf(out_file, "%04X ", buffer[offset]);
      else
        fprintf(out_file, "     ");
    fprintf(out_file, "   : %02u", offset-DUMP_WIDE);
    fprintf(out_file, "\n");
  }
 for (i=0; i != DUMP_WIDE;  fprintf(out_file, "  %01X  ", i++));
 fprintf(out_file, "\n");
 fclose(out_file);
}

void rt_buf_rd(char *str)                               /* ⥭    䠩 */
{
 int ch;

 int offset;
 unsigned short buffer2[RT_BUF_SIZE];

 while (*str == ' ' || *str == '\t') str++;
 if ((in_file=fopen(str, "rt")) == NULL)
 {
  msg_out(open_err);
  return;
 }
 strcpy(Window[nwin].data_fname, str);
 out_fname();
 fgets(buf_str, 80, in_file); /* ய ப ᪠ */
 fgets(buf_str, 80, in_file); /* ய ப ᪠ */
 offset=0;
 while (offset != RT_DUMP_SIZE)
 {
  if (fscanf(in_file, "%x ", &buffer2[offset]) != 1)
  {
   msg_out(format_err);
   return;
  }
  if ((++offset%DUMP_WIDE) == 0)
   while ((ch=fgetc(in_file)) != '\n')
    if (ch == EOF)
    {
     msg_out(format_err);
     return;
    }
 }
 for (offset=0; offset != RT_DUMP_SIZE; offset++)
  buffer[offset]=buffer2[offset];
 out_buffer();
 fclose(in_file);
}

void rt_buf_wr(char *str)                  /*     ࠢ  䠩 */
{

 int i, offset;

 while (*str == ' ' || *str == '\t') str++;
 if ((out_file=fopen(str, "wt")) == NULL)
 {
  msg_out(cr_err);
  return;
 }
 strcpy(Window[nwin].data_fname, str);
 out_fname();
 fprintf(out_file, "\n:\n");
 for (offset=0; offset < RT_DUMP_SIZE;)
 {
  for (i=0; i < DUMP_WIDE; i++, ++offset)
   if (offset < RT_DUMP_SIZE)
    fprintf(out_file, "%04X ", buffer[offset]);
   else
    fprintf(out_file, "     ");
  fprintf(out_file, "   : %02u", offset-DUMP_WIDE);
  fprintf(out_file, "\n");
 }
 for (i=0; i != DUMP_WIDE;  fprintf(out_file, "  %01X  ", i++));
 fprintf(out_file, "\n");
 fclose(out_file);
}

void set_base(char *str)
/*     ப: 1 - 訡, 0 -   浪 */
{
 unsigned short i;

 if (sscanf(str, "%x", &i) != 1)
 {
  msg_out(inp_err);
  return;
 }
 if (i > bcgetmaxbase())
 {
  msg_out(base_err);
  return;
 }
 base=i;
 out_base();
 bc_out_ram(base);
}

void set_ctrl_code(char *str)           /*  ⠭  ࠢ */
{
 char ch, *ptr;
 int ctrl_code2;

 while (*str == '\t' || *str == ' ') str++;
 ptr=str;
 while ((ch=*(ptr++)) != '\0')
  if (ch != '0' && ch != '1')
  {
   msg_out(bad_ctrl_code);
   return;
  }
 --ptr;
 if (ptr-str > CC_SIZE)
 {
  msg_out(bad_ctrl_code);
  return;
 }
 ptr=str;
 for (ctrl_code2=0; *ptr != '\0'; ptr++)
 {
  ctrl_code2<<= 1;
  if (*ptr == '1') ctrl_code2++;
 }
 if (!correct_cc(ctrl_code2))
 {
  sprintf(cc_no_def, " ࠢ %s  ।", str);
  msg_out(cc_no_def);
  return;
 }
 ctrl_code=ctrl_code2;
 out_ctrl_code();
}

void set_number(char *str)               /*  ⠭   */
{
 unsigned short i;

 if (sscanf(str, "%01x", &i) != 1)
 {
  msg_out(inp_err);
  return;
 }
 if (i > 2 || i == 0)
 {
  msg_out(bus_num_err);
  return;
 }
 bus_num = (i == 1) ? BUS_1 : BUS_2;
 if (bcdefbus(bus_num))
 {
  bus_num = BUS_1;
  msg_out(bus_num_err);
  return;
 }
 out_number();
}

void set_count(char *str)       /* ⠭ 横 ७  */
{
 unsigned long c;

 if (sscanf(str, "%U", &c) != 1)
 {
  msg_out(inp_err);
  return;
 }
 cmd_count=c;
 out_count();
}

void set_pause(char *str)            /*  ⠭  ⠩- */
{
 unsigned short p;

 if (sscanf(str, "%U", &p) != 1)
 {
  msg_out(inp_err);
  return;
 }
 if (p > 54923)
 {
  msg_out("ᨬ쭮 祭  - 54923 .");
  return;
 }
 opause = p;
 pause = (unsigned short)((unsigned long)p * 11932L / 10000L);
 out_pause();
}

void set_cpage(char *str)                 /* ⠭ ⥪饩 ࠭  */
{
 unsigned short p;

 if (sscanf(str, "%u", &p) != 1)
 {
  msg_out(inp_err);
  return;
 }
 switch (rtdefpagebus(p))
 {
 case RT_BAD_FUNC:
  msg_out("  ⤥쭮 ࠭   ");
  break;
 case RT_BAD_PAGE:
  msg_out("୮ 祭 ࠭ ");
  break;
 case 0:
  cram_page=p;
  out_page();
  break;
 }
}

void set_spage(char *str)                 /* ⠭ ⥪饩 ࠭  */
{
 unsigned short p;

 if (sscanf(str, "%u", &p) != 1)
 {
  msg_out(inp_err);
  return;
 }
 switch (rtdefpagepc(p))
 {
 case RT_BAD_FUNC:
  msg_out("  ⤥쭮 ࠭   ");
  break;
 case RT_BAD_PAGE:
  msg_out("୮ 祭 ࠭ ");
  break;
 case 0:
  bram_page=p;
  out_page();
  rtdefsubaddr(dir, subadr);
  rt_out_ram(dir, subadr);
  break;
 }
}

void set_page(char *str)       /* ⠭ ⥪饩 ࠭  */
{
 unsigned short p;

 if (sscanf(str, "%u", &p) != 1)
 {
  msg_out(inp_err);
  return;
 }
 if (rtdefpage(p))
  msg_out("୮ 祭 ࠭ ");
 else
 {
  cram_page=bram_page=p;
  out_page();
  rtdefsubaddr(dir, subadr);
  rt_out_ram(dir, subadr);
 }
}

int wr_at(TMK_DATA at)
{
 int res;

 switch (res = rtdefaddress(at))
 {
 case RT_BAD_FUNC:
#ifdef STEND
  set_lpt_data(at);
  terminal_adr = at;
  res = 0;
#endif
 case RT_BAD_ADDRESS:
  break;
 case 0:
  terminal_adr = at;
 }
// rtenable(RT_ENABLE);
 return res;
}

void set_at(char *str)                          /* ⠭   */
{
 unsigned short p;

 if (sscanf(str, "%u", &p) != 1)
 {
  msg_out(inp_err);
  return;
 }
#ifndef STEND
 if (Window[nwin].at_avail)
#endif
  if (wr_at(p))
   msg_out("୮ 祭  ");
  else
   out_at();
#ifndef STEND
 else
  msg_out(" ணࠬ   ");
#endif
}

void set_subadr_r(char *str)      /* ⠭ ,  ਥ */
{
 if (set_subadr(str)) return;
 dir = RT_RECEIVE;
 rtdefsubaddr(dir, subadr);
 out_subadr();
 rt_out_ram(dir, subadr);
}

void set_subadr_t(char *str)      /* ⠭ ,  । */
{
 if (set_subadr(str)) return;
 dir = RT_TRANSMIT;
 rtdefsubaddr(dir, subadr);
 out_subadr();
 rt_out_ram(dir, subadr);
}

int set_subadr(char *str)            /*     ப */
{                                    /* 1 - 訡, 0 -   浪 */
 unsigned short i;

 if (sscanf(str, "%x", &i) != 1)
 {
  msg_out(inp_err);
  return 1;
 }
 if (i > 31)
 {
  msg_out(subadr_err);
  return 1;
 }
 subadr=i;
 return 0;
}

void set_sw_bits(char *str, TMK_DATA mask)                    /* ⠭ ⮢  */
{
 if (end_ctrl(str)) return;
 rtsetanswbits(mask);
 out_status_word();
}


void clear_sw_bits(char *str, TMK_DATA mask)                  /*  ⮢  */
{
 if (end_ctrl(str)) return;
 rtclranswbits(mask);
 out_status_word();
}

void set_status_word(char *str)         /*  ⠭ ⢥⭮ ᫮ */
{
 char ch, *ptr;
 TMK_DATA status_word;

 while (*str == '\t' || *str == ' ') str++;
 ptr=str;
 while ((ch=*(ptr++)) != '\0')
  if (ch != '0' && ch != '1')
  {
   msg_out(bad_status_word);
   return;
  }
 --ptr;
 if (ptr-str > SW_SIZE)
 {
  msg_out(bad_status_word);
  return;
 }
 ptr=str;
 for (status_word=0; *ptr != '\0'; ptr++)
 {
  status_word<<= 1;
  if (*ptr == '1') status_word++;
 }
 rtclranswbits((TMK_DATA)(~status_word));
 rtsetanswbits(status_word);
 out_status_word();
}

void select_window(int nwindow)
{
 nwin = nwindow;
/*
 if (avtomat)
  nmainwin = nwin;
*/
 tmkselect(Window[nwin].nTMK);
 switch (Window[nwin].nMode)
 {
 case BC_MODE:
  if (!avtomat)
   base = bcgetbase();
  DUMP_STRINGS = BC_DUMP_STRINGS;
  DUMP_SIZE = BC_DUMP_SIZE;
  buf_size = BC_BUF_SIZE;
  break;
 case RT_MODE:
  if (!avtomat)
  {
   subadr = rtgetsubaddr();
   dir = subadr & RT_TRANSMIT;
   subadr &= ~RT_TRANSMIT;
  }
  DUMP_STRINGS = RT_DUMP_STRINGS;
  DUMP_SIZE = RT_DUMP_SIZE;
  buf_size = RT_BUF_SIZE;
 }
 if (avtomat || fInt)
  window(Window[nwin].nX + 1, Window[nwin].nY, 
         Window[nwin].nX + Window[nwin].nDX - 3, 
         Window[nwin].nY + Window[nwin].nDY - 1);
}

void my_wait(unsigned short pause)
{
/*
 unsigned short time1, dtime;

 time1 = get_timer();
 while (time1-get_timer() < pause);
*/
// struct timespec time1, time2;
 unsigned long ltime1, ltime2, d_usec;
 
 ltime1 = GetTickCount();
// getclock(TIMEOFDAY, &time1);
 do
 {
  ltime2 = GetTickCount();
  d_usec = (ltime2 - ltime1) * 1000L;
/*
  getclock(TIMEOFDAY, &time2);
  d_usec=(time2.tv_sec-time1.tv_sec)*1000000L+
         time2.tv_nsec/1000L-time1.tv_nsec/1000L;
*/
 }
 while (d_usec < (unsigned long)pause); 
}

void CheckTmkEvent(int fWaitEvent)
{
 TTmkEventData tmkEvD;
 DWORD dwEvent;
 int nSaveTmk;
 int nTmk;

// if (fWaitEvent == NO_WAIT_EVENT)
 {
//  while (1)
//  {
   if (fWaitEvent == NO_WAIT_EVENT)
     dwEvent = WaitForMultipleObjects(nWaitEvents, ahWaitEvents, FALSE, 0) - WAIT_OBJECT_0;
   else
     dwEvent = WaitForMultipleObjects(nWaitEvents, ahWaitEvents, FALSE, 100) - WAIT_OBJECT_0;
   if (dwEvent < (DWORD)nWaitEvents)
   {
    ResetEvent(ahWaitEvents[dwEvent]);
    nSaveTmk = tmkselected();
    nTmk = anWaitTmks[dwEvent];
    if (nSaveTmk != nTmk)
     tmkselect(nTmk);
//    printf("TMK%d", nTmk);
    while (1)
    {
     tmkgetevd(&tmkEvD);
     if (tmkEvD.nInt == 0)
      break;
//     printf("INT%d ", tmkEvD.nInt);
     int_num[nTmk] = tmkEvD.nInt;
     switch (tmkEvD.wMode)
     {
     case BC_MODE:
      bc_sw = tmkEvD.bc.wResult;
      if (tmkEvD.nInt == 1)
       ++good_starts;
      else
      {
       bc_aw1 = tmkEvD.bc.wAW1;
       bc_aw2 = tmkEvD.bc.wAW2;
       if (bad_starts < (unsigned long)BADLEN)
       {
        bad_sts[(unsigned)bad_starts] = bad_starts + good_starts + 1L;
        bad_sws[(unsigned)bad_starts] = bc_sw;
        bad_aws[(unsigned)bad_starts] = bc_aw1;
       }
       ++bad_starts;
      }
      break;
     case RT_MODE:
      if (tmkEvD.nInt == 1)
      {
       rt_cmd = tmkEvD.rt.wCmd;
       rt_sw = rtgetstate();
      }
      else if (tmkEvD.nInt == 2)
      {
       rt_sw = tmkEvD.rt.wStatus;
      }
      else
      {
       rt_sw = rtgetstate();
      }
      break;
     }
    }
    if (nSaveTmk != nTmk)
     tmkselect(nSaveTmk);
   }
//   break;
//  }
//  tmkselect(nSaveTmk);
 }
 CheckInput();
}
/*
int GetProxyTmkNum(pid_t msg)
{
 int i;

 for (i=0; i<nProxies; i++)
 {
  if (msg == aProxy[i])
   return aProxyTmkNum[i];
 }
 return -1;
}

int ProcessMsg(pid_t msg)
{
 int nSavTMK, nTMK;

 if ((nTMK = GetProxyTmkNum(msg)) != -1)
 { 
  nSavTMK = tmkselected();
  tmkselect(nTMK);
  tmkgetpxd(&TmkProxyData);
  switch(TmkProxyData.wMode)
  {
  case BC_MODE:
   switch(int_num[nTMK] = TmkProxyData.nInt)
   {
   case 1:
    bc_sw = TmkProxyData.bc.wResult;
    good_starts++;
    break;
   case 2:
    bc_sw = TmkProxyData.bc.wResult;
    bc_aw1 = TmkProxyData.bc.wAW1;
    bc_aw2 = TmkProxyData.bc.wAW2;
    if (bad_starts < (unsigned long)BADLEN)
    {
     bad_sts[(unsigned short)bad_starts] = bad_starts + good_starts + 1L;
     bad_sws[(unsigned short)bad_starts] = bc_sw;
     bad_aws[(unsigned short)bad_starts] = bc_aw1;
    }
    bad_starts++;
    break;
   }
   break;
  case RT_MODE:
   switch(int_num[nTMK] = TmkProxyData.nInt)
   {
   case 1:
    rt_cmd = TmkProxyData.rt.wCmd;
    rt_sw = rtgetstate();
    break;
   case 2:
   case 3:
    rt_sw = TmkProxyData.rt.wStatus;
    break;
   }
  }
  tmkselect(nSavTMK);
 }
 return nTMK;
}

void CheckTmkProxy(int fWaitProxy)
{
 pid_t proxy;
 int msg[1];

 if (fWaitProxy == WAIT_PROXY)
 {
  do
   if ((proxy = Receive(0, &msg, 0)) == -1)
    return; 
  while(ProcessMsg(proxy) == -1);
 }
 while ((proxy = Creceive(0, &msg, 0)) != -1)
  ProcessMsg(proxy);
}
*/

/*
void far BCIntNorm(unsigned short nResult, unsigned short nothing1, unsigned short nothing2)
{
 int_num[tmkselected()] = 1;
 bc_sw = nResult;
 good_starts++;
 bcrestore();
}

void far BCIntExc(unsigned short nResult, unsigned short AW1, unsigned short AW2)
{
 int_num[tmkselected()] = 2;
 bc_sw = nResult;
 bc_aw1 = AW1;
 bc_aw2 = AW2;
 if (bad_starts < (unsigned long)BADLEN)
 {
  bad_sts[(unsigned short)bad_starts] = bad_starts + good_starts + 1L;
  bad_sws[(unsigned short)bad_starts] = bc_sw;
  bad_aws[(unsigned short)bad_starts] = bc_aw1;
 }
 bad_starts++;
 bcrestore();
}

void far RTIntCmd(unsigned short nCmd)
{
 int_num[tmkselected()] = 1;
 rt_cmd = nCmd;
 rt_sw = rtgetstate();
 rtrestore();
}

void far RTIntErr(unsigned short nStatus)
{
 int_num[tmkselected()] = 2;
 rt_sw = nStatus;
 rtrestore();
}

void far RTIntData(unsigned short nStatus)
{
 int_num[tmkselected()] = 3;
 rt_sw = nStatus;
 rtrestore();
}
*/

void reset_mode()
{
 int mode = tmkgetmode();
 *Window[nwin].data_fname = '\0';
 if (mode == BC_MODE)
 {
  Window[nwin].nMode = BC_MODE;
  bus_num=bcgetbus();
  base=bcgetbase();
  buf_size = BC_BUF_SIZE;
 }
 else if (mode == RT_MODE)
 {
  Window[nwin].nMode = RT_MODE;
  if (hb_mode)
   rtdefmode((TMK_DATA)(rtgetmode()|RT_HBIT_MODE));
  else
   rtdefmode((TMK_DATA)(rtgetmode()&(~RT_HBIT_MODE)));
  rt_sw = rtgetstate();
  bram_page=cram_page=rtgetpage();
  subadr = rtgetsubaddr();
  dir = RT_TRANSMIT&subadr;
  subadr &= ~RT_TRANSMIT;
  Window[nwin].at_avail = (rtdefaddress(rtgetaddress())) ? 0 : 1;
//  rtenable(RT_ENABLE);
  buf_size = RT_BUF_SIZE;
 }
}

int set_mode(int mode)
{
// int result;

 *Window[nwin].data_fname = '\0';
/*
 if (tmkgetmode() != UNDEFINED_MODE)
  tmkundefmode();
 if (!(result=tmkdefmode(mode)))
 {
*/
 if (mode != tmkgetmode())
 {
  if (mode == BC_MODE)
  {
   bcreset();
   Window[nwin].nMode = BC_MODE;
   int_num[Window[nwin].nTMK] = 0;
   bcdefbus(bus_num=BUS_1);
   bcdefbase(base=0);
   buf_size = BC_BUF_SIZE;
  }
  else if (mode == RT_MODE)
  {
   rtreset();
   Window[nwin].nMode = RT_MODE;
   int_num[Window[nwin].nTMK] = 0;
   if (hb_mode)
    rtdefmode((TMK_DATA)(rtgetmode()|RT_HBIT_MODE));
   else
    rtdefmode((TMK_DATA)(rtgetmode()&(~RT_HBIT_MODE)));
   rt_sw = rtgetstate();
   rtdefpage(bram_page=cram_page=0);
   rtdefsubaddr(dir=RT_RECEIVE, subadr=1);
   Window[nwin].at_avail = (rtdefaddress(0)) ? 0 : 1;
//   rtenable(RT_ENABLE);
   buf_size = RT_BUF_SIZE;
   wr_at(10);
  }
 }
 else
  reset_mode();
// return result;
 return 0;
}

void main()
{
 int iTMK;

 hIn = GetStdHandle(STD_INPUT_HANDLE);
 hOut = GetStdHandle(STD_OUTPUT_HANDLE);
// textmode(C80);        /* ࠬ ࠭ */
 textcolor(LIGHTGRAY);
 textbackground(BLACK);
 clrscr();
/* _wscroll = 0;*/

/* oldvect3=getvect(0x05);      /* ࠭ ஥ 祭  */
/* setvect(0x05, prtscr_brk);     /* ⠭  祭  */

 setbuf(stdout, 0);
 biostime1 = GetTickCount();
// getclock(TIMEOFDAY, &biostime1);

 if (TmkOpen())
 {
  printf("訡  ⨨ ࠩ\n");
  exit(0);
 }
 if (TmkInit("tmk.cfg"))
 {
  printf("訡 㧪 䨣樨  䠩 TMK.CFG\n");
  tmkdone(ALL_TMKS);
  TmkClose();
  exit(0);
 }
#ifdef STEND
 init_lpt();
#endif
 nwin = 0;
// nProxies = 0;
 fInitBad = 0;
 sa4Event.nLength = sizeof(sa4Event);
 sa4Event.lpSecurityDescriptor = NULL;
 sa4Event.bInheritHandle = TRUE;
 nMaxTMK = tmkgetmaxn();
 for (iTMK = 0; iTMK <= nMaxTMK; iTMK++)
 {
  int_num[iTMK] = 0;
  if (tmkselect(iTMK))
   continue;
  tmkgetinfo(&(aTmkConfig[iTMK]));

  if (!(hEvent[iTMK] = CreateEvent(&sa4Event, TRUE, FALSE, NULL)))
  {
   printf("CreateEvent failed!\n");
   fInitBad = 1;
  }
  else
  {
   tmkdefevent(hEvent[iTMK], TRUE);
   ahWaitEvents[nWaitEvents] = hEvent[iTMK];
   anWaitTmks[nWaitEvents++] = iTMK;
  }
  ahWaitEvents[nWaitEvents] = hIn;
/*
  if (aTmkLock[iTMK] = tmk_lock())
  {
   fInitBad = 1;
   printf("TMK%d: Can't tmk_lock\n", iTMK);
  }
  if (aRtArbLock[iTMK] = rtarb_lock())
  {
   fInitBad = 1;
   printf("TMK%d: Can't rtarb_lock\n", iTMK);
  }
  if (aRtAnswLock[iTMK] = rtansw_lock())
  {
   fInitBad = 1;
   printf("TMK%d: Can't rtansw_lock\n", iTMK);
  }
*/
/*
  aTmkProxy[iTMK] = qnx_proxy_attach(0, 0, 0, -1);
  if (aTmkProxy[iTMK] == -1)
  {
   fInitBad = 1;
   printf("TMK%d: Can't attach proxy\n", iTMK);
  }
  else
  {
   tmkdefproxy(aTmkProxy[iTMK]);
   aProxy[nProxies] = aTmkProxy[iTMK];
   aProxyTmkNum[nProxies] = iTMK;
   ++nProxies;
  }
*/
/*
   bcdefintnorm(BCIntNorm);
   bcdefintexc(BCIntExc);
   rtdefintcmd(RTIntCmd);
   rtdefinterr(RTIntErr);
   rtdefintdata(RTIntData);
*/
 }
 if (fInitBad)
  make_quit();
 for (iTMK = 0; iTMK <= nMaxTMK; iTMK++)
 {
  if (tmkselect(iTMK))
   continue;
  if (nwin > nMaxWin)
   continue;
  if (nwin == 0)
   set_mode(BC_MODE);
  else
   set_mode(RT_MODE);
  Window[nwin].fVisible = 1;
  Window[nwin].nTMK = iTMK;
  Window[nwin].nType = -1;
  ++nwin;
 }
 select_window(nmainwin);
 all_screen();
 while (1)
 {                   /*   믮  */
  window(1, 1, 80, 25);
  in_cmd(cmd_str);
  window(Window[nwin].nX + 1, Window[nwin].nY, 
          Window[nwin].nX + Window[nwin].nDX - 2, 
          Window[nwin].nY + Window[nwin].nDY - 1);
  make_cmd(cmd_str);
 }
}

void block_data_irq(char *str)    /* ஢ 뢠  */
{
 if (end_ctrl(str)) return;
 rtdefirqmode((TMK_DATA)(rtgetirqmode()|RT_DATA_BL));
//  out_mode();
}

void unblock_data_irq(char *str)    /* ࠧ஢ 뢠  */
{
 if (end_ctrl(str)) return;
 rtdefirqmode((TMK_DATA)(rtgetirqmode()&(~RT_DATA_BL)));
//  out_mode();
}

void set_hbit_mode(char *str)    /*  ࠢ ०
                                    ⭮  */
  {
  int res;

  while (*str=='\t' || *str==' ') str++;
  switch (*str)
  {
  case '0': res = rtdefmode((TMK_DATA)(rtgetmode()&(~RT_HBIT_MODE)));
            hb_mode = 0;
            break;
  case '1': res = rtdefmode((TMK_DATA)(rtgetmode()|RT_HBIT_MODE));
            hb_mode = 1;
            break;
  }
  out_rt_mode();
  }

void set_flag_mode(char *str)    /*  ࠢ ० 䫠 */
  {
  int res;

  while (*str=='\t' || *str==' ') str++;
  switch (*str)
  {
  case '0': res = rtdefmode((TMK_DATA)(rtgetmode()&(~RT_FLAG_MODE)));
            break;
  case '1': res = rtdefmode((TMK_DATA)(rtgetmode()|RT_FLAG_MODE));
            break;
  }
//  out_mode();
  }

void set_brcst_mode(char *str)    /*  ࠢ ०
                                     㯯  */
  {
  int res;

  while (*str=='\t' || *str==' ') str++;
  switch (*str)
  {
  case '0': res = rtdefmode((TMK_DATA)(rtgetmode()&(~RT_BRCST_MODE)));
            break;
  case '1': res = rtdefmode((TMK_DATA)(rtgetmode()|RT_BRCST_MODE));
            break;
  }
//  out_mode();
  }


void make_cmd(char *str)
/* ࠡ⪠  ப, 室  믮  */
{
 strcpy(old_cmd, cmd_str);
 while (*str == ' ' || *str == '\t') str++;
 if (!strcmp(str, "Q"))
  make_quit();
 else if (!strncmp(str, "IOD ", 4))
  set_io_delay(str+4);
 else if (!strncmp(str, "I", 1))
  cmd_reset(str+1);
 else if (!strncmp(str, "F", 1))
  fields_chg(str+1);
 else if (!strncmp(str, "BE", 2))
  buf_edit(str+2);
 else if (!strncmp(str, "BC", 2))
  buf_clear(str+2);
 else if (!strncmp(str, "BF ", 3))
  buf_fill(str+3);
 else if (!strncmp(str, "SL ", 3))
  set_stat_len(str+3);
 else if (!strncmp(str, "WIN ", 4))
  select_win(str+4);
 else if (!strncmp(str, "TMK ", 4))
  select_tmk(str+4);
 else if (!strncmp(str, "MBC", 3))
  mode_bc(str+3);
 else if (!strncmp(str, "MRT", 3))
  mode_rt(str+3);
// else if (!strncmp(str, "MMT", 3))
//  mode_mt(str+3);
 else if (!strncmp(str, "AVT", 3))
  avt_ctrl(str+3);
 else if (!strncmp(str, "ATBC", 4))
 {
  fReserv=0;
  avt_bc(str+4);
 }
 else if (!strncmp(str, "RATBC", 5))
 {
  fReserv=1;
  avt_bc(str+5);
 }
 else if (!strncmp(str, "ATRT", 4))
 {
  fReserv=0;
  avt_rt(str+4);
 }
 else if (!strncmp(str, "RATRT", 5))
 {
  fReserv=1;
  avt_rt(str+5);
 }
 else if (!strncmp(str, "BA", 2))
  avt_va996(str+2);
 else if (!strncmp(str, "ATFL", 4))
  avt_flags(str+4);
 else if (!strncmp(str, "STOP?", 4))
 {
  if (enter_mode && bad_starts>0L)
   fSkipCmds=1;
 }
 else if (!strncmp(str, ";", 1))
  comment(str+1);
 else if (!strncmp(str, "#", 1))
  ;
 else
 if (Window[nwin].nMode == BC_MODE)
 {
  if (!strncmp(str, "SB ", 3))
   set_base(str+3);
  else if (!strncmp(str, "SN ", 3))
   set_number(str+3);
  else if (!strncmp(str, "SP ", 3))
   set_pause(str+3);
  else if (!strncmp(str, "SC ", 3))
   set_ctrl_code(str+3);
  else if (!strncmp(str, "P", 1))
   kbd_pause(str+1);
  else if (!strncmp(str, "GL", 2))
   start_loop(str+2);
  else if (!strncmp(str, "G", 1))
   start_1(str+1);
  else if (!strncmp(str, "STO", 3))
   statistic_out(str+3);
  else if (!strncmp(str, "STBO", 4))
   statistic_bad_out(str+4);
  else if (!strncmp(str, "STC", 3))
   statistic_clear(str+3);
  else if (!strncmp(str, "A+", 2))
   fAAAA=1;
  else if (!strncmp(str, "A-", 2))
   fAAAA=0;
  else if (!strncmp(str, "R ", 2))
   bc_buf_rd(str+2);
  else if (!strncmp(str, "W ", 2))
   bc_buf_wr(str+2);
  else if (!strncmp(str, "R<", 2) && cmd_count == 1)
   cmds_open(str+3);
  else if (!strncmp(str, "R<", 2) && cmd_count != 1)
   cmds_open2(str+3);
  else if (!strncmp(str, "C ", 2))
   set_count(str+2);
  else if (!strncmp(str, "T", 1))
   bc_ram_test(str+1);
  else if (!strncmp(str, "H", 1))
   bc_help(str+1);
  else if (!strncmp(str, "SYM", 3))
   sym(str+3);
  else if (*str != '\0')
   msg_out(undef_cmd);
 }
 else if (Window[nwin].nMode == RT_MODE)
 {
  if (!strncmp(str, "SW ", 3))
   set_status_word(str+3);
  else if (!strncmp(str, "HBIT ", 5))
    set_hbit_mode(str+5);
  else if (!strncmp(str, "FLAG ", 5))
    set_flag_mode(str+5);
  else if (!strncmp(str, "BCST ", 5))
    set_brcst_mode(str+5);
  else if (!strncmp(str, "SB1", 3))
    block_data_irq(str+3);
  else if (!strncmp(str, "CB1", 3))
    unblock_data_irq(str+3);
  else if (!strncmp(str, "SFL", 3))
   set_flag(str+3);
  else if (!strncmp(str, "WRC", 3))
   wr_mr_loop(str+3);
  else if (!strncmp(str, "RDC", 4))
   rd_sw_loop(str+4);
  else if (!strncmp(str, "SSR", 3))
   set_sw_bits(str+3, SREQ);
  else if (!strncmp(str, "SBS", 3))
   set_sw_bits(str+3, BUSY);
  else if (!strncmp(str, "SSF", 3))
   set_sw_bits(str+3, SSFL);
  else if (!strncmp(str, "STF", 3))
   set_sw_bits(str+3, RTFL);
  else if (!strncmp(str, "SDN", 3))
   set_sw_bits(str+3, DNBA);
  else if (!strncmp(str, "CSR", 3))
   clear_sw_bits(str+3, SREQ);
  else if (!strncmp(str, "CBS", 3))
   clear_sw_bits(str+3, BUSY);
  else if (!strncmp(str, "CSF", 3))
   clear_sw_bits(str+3, SSFL);
  else if (!strncmp(str, "CTF", 3))
   clear_sw_bits(str+3, RTFL);
  else if (!strncmp(str, "CDN", 3))
   clear_sw_bits(str+3, DNBA);
  else if (!strncmp(str, "SMR", 3))
  {
   rtlock(dir, subadr);
   fLock=1;
  }
  else if (!strncmp(str, "CMR", 3))
  {
   rtdefsubaddr(dir, subadr);
//   rtunlock(dir, subadr);
   fLock=0;
  }
  else if (!strncmp(str, "SR ", 3))
   set_subadr_r(str+3);
  else if (!strncmp(str, "ST ", 3))
   set_subadr_t(str+3);
  else if (!strncmp(str, "SPG ", 4))
   set_spage(str+4);
  else if (!strncmp(str, "CPG ", 4))
   set_cpage(str+4);
  else if (!strncmp(str, "PG ", 3))
   set_page(str+3);
  else if (!strncmp(str, "P", 1))
   kbd_pause(str+1);
  else if (!strncmp(str, "SAT ", 4))
   set_at(str+4);
  else if (!strncmp(str, "RSW", 3))
   read_sw(str+3);
  else if (!strncmp(str, "R ", 2))
   rt_buf_rd(str+2);
  else if (!strncmp(str, "W ", 2))
   rt_buf_wr(str+2);
  else if (!strncmp(str, "R<", 2))
   cmds_open(str+3);
  else if (!strncmp(str, "T", 1))
   rt_ram_test(str+1);
  else if (!strncmp(str, "H", 1))
   rt_help(str+1);
  else if (*str != '\0')
   msg_out(undef_cmd);
 }
}

void make_quit()                    /* প 室  ⫠稪 */
{
 int iTMK;
/* setvect(0x05, oldvect3);*/    /* ⠭  */
 for (iTMK = 0; iTMK <= nMaxTMK; ++iTMK)
 {
  if (tmkselect(iTMK))
   continue;
  if (hEvent[iTMK])
   CloseHandle(hEvent[iTMK]);
/*
  tmkundefmode();
  if (!aTmkLock[iTMK])
   tmk_unlock();
  if (!aRtArbLock[iTMK])
   rtarb_unlock();
  if (!aRtAnswLock[iTMK])
   rtansw_unlock();
  if (aTmkProxy[iTMK] != -1)
   qnx_proxy_detach(aTmkProxy[iTMK]);
*/
 }
 tmkdone(ALL_TMKS);
 TmkClose();
 window(1, 1, 80, 25);
 if (!fInitBad)
  clrscr();
 printf(" ⫠稪 祭.\n");
 exit(0);
}

void set_io_delay(char *str)
{
 unsigned short nDelay;

 while (*str == '\t' || *str == ' ') str++;
 if (*str == '\0' || sscanf(str, "%d", &nDelay) != 1)
 {
  msg_out(inp_err);
  return;
 }
// tmkiodelay(nDelay);
 out_type();
}

void select_win(char *str)
{
 int nwin;

 while (*str == '\t' || *str == ' ') str++;
 if (*str == '\0' || sscanf(str, "%d", &nwin) != 1)
 {
  msg_out(inp_err);
  return;
 }
 if (nwin > 1)
 {
  msg_out("⨬  ஢   0  1");
  return;
 }
 nmainwin = nwin;
// int_num[Window[0].nTMK] = 0;
// int_num[Window[1].nTMK] = 0;
 select_window(nmainwin);
 all_screen();
}

void mode_bc(char *str)
{
 if (end_ctrl(str)) return;
 int_num[Window[nwin].nTMK] = 0;
 if (set_mode(BC_MODE))
 {
  msg_out("Can't set BC_MODE");
  return;
 }
 base = 0;
 bcdefbase(0);
 all_screen();
}

void mode_rt(char *str)
{
 if (end_ctrl(str)) return;
 if (set_mode(RT_MODE))
 {
  msg_out("Can't set RT_MODE");
  return;
 }
 cram_page = bram_page = 0;
 rtdefpage(0);
 dir = RT_RECEIVE;
 subadr = 1;
 rtdefsubaddr(dir, subadr);
 all_screen();
}

void select_tmk(char *str)
{
 int ntmk;

 while (*str == '\t' || *str == ' ') str++;
 if (*str == '\0' || sscanf(str, "%U", &ntmk) != 1)
 {
  msg_out(inp_err);
  return;
 }
 if (ntmk > MAX_TMK_NUMBER)
 {
  msg_out("⨬  ஢   0  max");
  return;
 }
 if (tmkselect(ntmk))
 {
  msg_out("  ⠪ ஬    䠩 䨣樨");
  return;
 }
 if (ntmk == Window[!nmainwin].nTMK)
 {
//  set_mode(Window[!nmainwin].nMode);
  msg_out("         ");
  return;
 }
 nwin = nmainwin;
 switch (tmkgetmode())
 {
 case BC_MODE:
 case RT_MODE:
  reset_mode();
  break;
 case UNDEFINED_MODE:
  set_mode(BC_MODE);
  break;
 }
 Window[nmainwin].nTMK = ntmk;
 Window[nmainwin].nType = -1;
 select_window(nmainwin);
 all_screen();
}

void set_stat_len(char *str)
{
 unsigned long cnt;

 while (*str == '\t' || *str == ' ') str++;
 if (*str != '\0')
 {
  if (sscanf(str, "%U", &cnt) != 1)
  {
   msg_out(inp_err);
   return;
  }
  GL_COUNTER = cnt;
  GL_COUNTER2 = cnt * 2;
  GL_COUNTER3 = cnt * 4;
 }
}

void sym(char *str)                                      /* ᨬ஢ */
{
 int cur_base, cur_ctrl_code;

 if (end_ctrl(str)) return;
 cur_base=base;
 cur_ctrl_code=ctrl_code;
 ctrl_code = DATA_BC_RT_BRCST; /* .  ࠢ */
                               /* ᥭ ⠭   */
 set_base("0"); buf_fill("1, 32, AAAA");
 bcputw(0, (0x1F<<11) | RT_RECEIVE | (0x11<<5));
 set_base("1"); buf_fill("1, 32, 0000");
 bcputw(0, (0x1F<<11) | RT_RECEIVE | (0x11<<5));
 set_base("2"); buf_fill("1, 32, 5555");
 bcputw(0, (0x1F<<11) | RT_RECEIVE | (0x11<<5));
 set_base("3"); buf_fill("1, 32, FFFF");
 bcputw(0, (0x1F<<11) | RT_RECEIVE | (0x11<<5));
 set_base("4"); buf_fill("1, 32, 8000");
 bcputw(0, (0x1F<<11) | RT_RECEIVE | (0x11<<5));
 set_base("5"); buf_fill("1, 32, 7FFF");
 bcputw(0, (0x1F<<11) | RT_RECEIVE | (0x11<<5));
 gotoxy(1, Window[nwin].nDY);
 textcolor(CYAN);
 printf("প ᨬ஢.  PrtScr  室...");
 textcolor(LIGHTGRAY);
 while (!prtscr_flag)
 {
  base=0; start();
  base=1; start();
  base=2; start();
  base=3; start();
  base=4; start();
  base=5; start();
 }
 prtscr_flag = 0;
 textcolor(WHITE);
 gotoxy(1, Window[nwin].nDY);
 hor_line(Window[nwin].nDX-2);
 textcolor(LIGHTGRAY);
 ctrl_code=cur_ctrl_code;
 base=cur_base;
 out_ctrl_code();
 out_base();
 bc_out_ram(base);
}

void bc_clear_ram()
{
 int k, maxbase;

 maxbase = bcgetmaxbase();
 for (k = 0; k <= 63; k++)
  buffer[k] = 0;
 for (base = 0; base <= maxbase; base++)
 {
  bcdefbase(base);
  bcputblk(0, buffer, 64);
 }
 base = 0;
 bcdefbase(0);
 out_base();
 out_buffer();
}

void rt_clear_ram()
{
 int k, maxpage;
 TMK_DATA page;

 maxpage = rtgetmaxpage();
 for (k = 0; k <= 31; k++)
  buffer[k] = 0;
 for (page = 0; page <= maxpage; page++)
 {
  rtdefpage(page);
  for (subadr = 0; subadr <= 31; subadr++)
  {
   rtdefsubaddr(RT_RECEIVE, subadr);
   rtputblk(0, buffer, 32);
   rtdefsubaddr(RT_TRANSMIT, subadr);
   rtputblk(0, buffer, 32);
  }
 }
 cram_page = bram_page = 0;
 rtdefpage(0);
 dir = RT_RECEIVE;
 subadr = 1;
 rtdefsubaddr(dir, subadr);
 out_page();
 out_subadr();
 out_buffer();
}

int bc_ram_test(char *str)                         /* ஢  */
{
 int k, error, bases;

 if (end_ctrl(str)) return 0;
 bases = bcgetmaxbase() + 1;
 clear_dump();
 gotoxy(1, BDUMP_Y-3);
 hor_line(78);
 gotoxy(1, BDUMP_Y-2);
 clreol();
 printf("      0               1               2               3");
 gotoxy(1, BDUMP_Y-1);
 printf(": 0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF");
 gotoxy(1, BDUMP_Y);
 printf("  00:");
 gotoxy(1, BDUMP_Y+1);
 printf("  40:");
 gotoxy(1, BDUMP_Y+4);
 printf("       : \xB0, \xB1 -  襫, ");
 textcolor(RED); putchar('B');
 textcolor(LIGHTGRAY); printf(" - ᡮ ⮪.");
 
 srand(1);
 for (base = 0; base < bases; base++)
 {
  for (k = 0; k <= 63; k++)
   buffer[k] = rand() + rand();
  bcdefbase(base);
  bcputblk(0, buffer, 64);
  if (base % 64 == 0)
   gotoxy(7, base / 64 + BDUMP_Y);
  putchar('.');
 }
 
 srand(1);
 for (base = 0; base < bases; base++)
 {
  bcdefbase(base);
  bcgetblk(0, buffer, 64);
  error = 0;
  for (k = 0; k <= 63; k++)
  {
   if (buffer[k] != (unsigned short)(rand() + rand()))
   {
    error = 1;
    break;
   }
  }
  if (base % 64 == 0)
   gotoxy(7, base / 64 + BDUMP_Y);
  if (error)
  {
   textcolor(RED); putchar('B'); textcolor(LIGHTGRAY);
  }
  else
   putchar('\xB0');
 }
 msg_out("אַ   襭");
 for (base = 0; base < bases; base++)
 {
  bcdefbase(base);
  bcgetblk(0, buffer, 64);
  for (k = 0; k <= 63; k++)
   buffer[k] = ~buffer[k];
  bcputblk(0, buffer, 64);
  if (base % 64 == 0)
   gotoxy(7, base / 64 + BDUMP_Y);
  putchar('.');
 }
 srand(1);
 for (base = 0; base < bases; base++)
 {
  bcdefbase(base);
  bcgetblk(0, buffer, 64);
  error = 0;
  for (k = 0; k <= 63; k++)
  {
   if (buffer[k] != (unsigned short)~(rand() + rand()))
   {
    error = 1;
    break;
   }
  }
  if (base % 64 == 0)
   gotoxy(7, base / 64 + BDUMP_Y);
  if (error)
  {
   textcolor(RED); putchar('B'); textcolor(LIGHTGRAY);
  }
  else
   putchar('\xB1');
 }
 msg_out("   襭");
 gotoxy(1, BDUMP_Y-3);
 clreol();
 gotoxy(1, BDUMP_Y-2);
 clreol();
 clear_dump();
// bc_clear_ram();
 base = 0;
 out_base();
 bc_out_ram(base);
 out_ctrl_code();
 bc_out_sw();
 out_inn();
}

int rt_ram_test(char *str)                         /* ஢  */
{
 int k, error;
 TMK_DATA page, pages;

 if (end_ctrl(str)) return 0;
 pages = rtgetmaxpage() + 1;
 clear_dump();
 gotoxy(1, BDUMP_Y-3);
 hor_line(78);
 gotoxy(1, BDUMP_Y-2);
 clreol();
 printf("          0          1          0       1    ");
 gotoxy(1, BDUMP_Y-1);
 printf(": 0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF0123456789ABCDEF");
 gotoxy(1, BDUMP_Y);
 printf("  . 0:");
 gotoxy(1, BDUMP_Y+1);
 printf("  . 1:");
 gotoxy(1, BDUMP_Y+2);
 printf("  . 2:");
 gotoxy(1, BDUMP_Y+3);
 printf("  . 3:");
 gotoxy(1, BDUMP_Y+4);
 printf("           : \xB0, \xB1 -  襫, ");
 textcolor(RED); putchar('B');
 textcolor(LIGHTGRAY); printf(" - ᡮ ⮪.");
 
 srand(1);
 for (page = 0; page < pages; page++)
 {
  rtdefpage(page);
  gotoxy(11, page + BDUMP_Y);
  for (dir = RT_RECEIVE; ; dir = RT_TRANSMIT)
  {
   for (subadr = 0; subadr <= 31; subadr++)
   {
    for (k = 0; k <= 31; k++)
     buffer[k] = rand() + rand();
    rtdefsubaddr(dir, subadr);
    rtputblk(0, buffer, 32);
    putchar('.');
   }
   if (dir == RT_TRANSMIT)
    break;
  }
 }
 srand(1);
 for (page = 0; page < pages; page++)
 {
  rtdefpage(page);
  gotoxy(11, page + BDUMP_Y);
  for (dir = RT_RECEIVE; ; dir = RT_TRANSMIT)
  {
   for (subadr = 0; subadr <= 31; subadr++)
   {
    rtdefsubaddr(dir, subadr);
    rtgetblk(0, buffer, 32);
    error = 0;
    for (k = 0; k <= 31; k++)
    {
     if (buffer[k] != (unsigned short)(rand() + rand()))
     {
      error = 1;
      break;
     }
    }
    if (error)
    {
     textcolor(RED); putchar('B'); textcolor(LIGHTGRAY);
    }
    else
     putchar('\xB0');
   }
   if (dir == RT_TRANSMIT)
    break;
  }
 }
 msg_out("אַ   襭");
 for (page = 0; page < pages; page++)
 {
  rtdefpage(page);
  gotoxy(11, page + BDUMP_Y);
  for (dir = RT_RECEIVE; ; dir = RT_TRANSMIT)
  {
   for (subadr = 0; subadr <= 31; subadr++)
   {
    rtdefsubaddr(dir, subadr);
    rtgetblk(0, buffer, 32);
    for (k = 0; k <= 31; k++)
     buffer[k] = ~buffer[k];
    rtputblk(0, buffer, 32);
    putchar('.');
   }
   if (dir == RT_TRANSMIT)
    break;
  }
 }
 srand(1);
 for (page = 0; page < pages; page++)
 {
  rtdefpage(page);
  gotoxy(11, page + BDUMP_Y);
  for (dir = RT_RECEIVE; ; dir = RT_TRANSMIT)
  {
   for (subadr = 0; subadr <= 31; subadr++)
   {
    rtdefsubaddr(dir, subadr);
    rtgetblk(0, buffer, 32);
    error = 0;
    for (k = 0; k <= 31; k++)
    {
     if (buffer[k] != (unsigned short)~(rand() + rand()))
     {
      error = 1;
      break;
     }
    }
    if (error)
    {
     textcolor(RED); putchar('B'); textcolor(LIGHTGRAY);
    }
    else
     putchar('\xB1');
   }
   if (dir == RT_TRANSMIT)
    break;
  }
 }
 msg_out("   襭");
 gotoxy(1, BDUMP_Y-3);
 clreol();
 gotoxy(1, BDUMP_Y-2);
 clreol();
 clear_dump();
// rt_clear_ram();
 dir = RT_RECEIVE;
 subadr = 0x10;
 out_subadr();
 rt_out_ram(dir, subadr);
 out_status_word();
 rt_out_sw();
 out_inn();
}

void comment(char *str)                          /* 뢮  */
{
 gotoxy(1, 10);
 clreol();
 printf(str);
 
}

void kbd_pause(char *str)                        /* ணࠬ㥬 㧠 */
{
 unsigned long p;

 while (*str == '\t' || *str == ' ') str++;
 if (*str != '\0')
 {                                  /* 㧠 ணࠬ㥬 ⥫쭮 */
  if (sscanf(str, "%U", &p) != 1)
  {
   msg_out(inp_err);
   return;
  }
  for (; p-- ;);
  return;
 }
 gotoxy(1, 10);                          /*    */
 textcolor(CYAN);
 printf("㧠. ESC -    ०, 㣠 - த 믮.");
 textcolor(LIGHTGRAY);
 while (kbhit() == 0)
  WaitForMultipleObjects(nWaitEvents+1, ahWaitEvents, FALSE, 0);
 gotoxy(1, 10);
 clreol();
 if ((bioskey()&0x00FF) == ESCAPE)
  if (enter_mode)
  {
   fclose(cmd_file);
   enter_mode=0;
  }
}

void statistic_bad_out(char *str)                        /* 뢮 ⨪  */
{
 int savenDY;
 unsigned short i;

 if (end_ctrl(str)) return;
 window(1, 1, 80, 23);
 clrscr();
 printf(" N   ..    .᫮      N   ..    .᫮\015\012");
 for (i = 0; (unsigned long)i < bad_starts && i < 42; i++)
 {
  printf("%9u  ", bad_sts[i]);
  out_bin(bad_sws[i], 7);
  printf("  ");
  out_bin(bad_aws[i], 16);
  if (i & 1)
   printf(" \015\012");
  else
   printf(" ");
 }
 savenDY = Window[nwin].nDY;
 Window[nwin].nDY = 23;
 
 msg_out(" ⨪ ᡮ");
 Window[nwin].nDY = savenDY;
 all_screen();
}

void statistic_out(char *str)                    /* 뢮 ⨪  */
{
 if (end_ctrl(str)) return;
 gotoxy(1, 10); clreol();
 printf("    C⮢ - %lu, 뢠_2 - %lu, ", good_starts+bad_starts+to_errors, bad_starts);
 printf("訡 - %lu, TO_訡 - %lu.", channel_err, to_errors);
 
 if (avtomat) return;
 msg_out("⨪ ");
 gotoxy(1, 10); clreol();
}

void statistic_clear(char *str)          /* ⪠ ६ ⨪ */
{
 if (end_ctrl(str)) return;
 to_errors=channel_err=good_starts=bad_starts=0;
 gotoxy(1, 10); clreol();
}

void fields_chg(char *str)                    /* ࠢ 뤥  */
{
 if (end_ctrl(str)) return;
 fields = !fields;
 all_screen();
}

void bc_help(char *str)                                  /* 뢮 ᪠ */
{
 int savenDY;

 if (end_ctrl(str)) return;
 window(1, 1, 80, 23);
 clrscr();
 printf("               ᭮  ⫠稪  ०  :\015\012");
 printf("TMK number_D - 롮   ⥪饬 \015\012");
 printf("SC code_B   -   ࠢ\015\012");
 printf("SB base_H   -  \015\012");
 printf("SP pause_D  -    ⠬\015\012");
 printf("SN number_D -   \015\012");
 printf("BE [adr_D, data_H] - ।஢ \015\012");
 printf("BC - ⪠ \015\012");
 printf("BF start_D, end_D, data_H -   ⠭⮩\015\012");
 printf("I -  (樠) ஫ \015\012");
 printf("F - ⠭/ 뤥  ଠ\015\012");
 printf("G -  \015\012");
 printf("GL -    横\015\012");
 printf("STO/STC - 뢮/⪠ ⨪ \015\012");
 printf("T -    \015\012");
 printf("R filename - ⥭    䠩        W filename -    䠩\015\012");
 printf("R< filename -    䠩\015\012");
 printf("P [pause_D] - 㧠 ணࠬ㥬 ⥫쭮\015\012");
 printf("C count_D - ⠭ ᫠ ஢  䠩\015\012");
 printf(";... - ਩\015\012");
 printf("Q  - 室  ⫠稪                     H  -  \015\012");
 
 savenDY = Window[nwin].nDY;
 Window[nwin].nDY = 23;
 msg_out(" ᪠");
 Window[nwin].nDY = savenDY;
 all_screen();
}

void rt_help(char *str)                                  /* 뢮 ᪠ */
{
 int savenDY;

 if (end_ctrl(str)) return;
 window(1, 1, 80, 23);
 clrscr();
 printf("                  ᭮  ⫠稪  ०  :\015\012");
 printf("TMK number_D - 롮   ⥪饬 \015\012");
 printf("SW code_B -  ⢥⭮ ᫮\015\012");
 printf("Sbit_name/Cbit_name - ⠭/  ⢥⭮ ᫮, \015\012");
 printf("                       bit_name - BS, RQ, TF, SF, DN\015\012");
 printf("SMR/CMR - ஢/ࠧ஢ \015\012");
 printf("SR/ST subadr_H -     ਥ/।\015\012");
 printf("SPG/CPG page_D -  ࠭   ஭ /\015\012");
 printf("SAT adr_D -     \015\012");
 printf("BE [adr_D, data_H] - ।஢ \015\012");
 printf("BF start_D, end_D, data_H -   ⠭⮩\015\012");
 printf("BC - ⪠ \015\012");
 printf("I -  (樠) 筮 ன⢠\015\012");
 printf("F - ⠭/ 뤥  ଠ\015\012");
 printf("RSW - ⥭ ᫮ ﭨ\015\012");
 printf("SFL - 横᪠  䫠\015\012");
 printf("WRC/RDC - 横᪠ /⥭ ॣ ०/ﭨ\015\012");
 printf("R filename - ⥭    䠩        W filename -    䠩\015\012");
 printf("R< filename -    䠩\015\012");
 printf("P [pause_D] - 㧠 ணࠬ㥬 ⥫쭮\015\012");
 printf(";... - ਩\015\012");
 printf("Q  - 室  ⫠稪                     H  - \015\012");
 
 savenDY = Window[nwin].nDY;
 Window[nwin].nDY = 23;
 msg_out(" ᪠");
 Window[nwin].nDY = savenDY;
 all_screen();
}

void cmds_open2(char *str)           /* 믮  䠩   横 */
{
 if (cmd_count == 0) return;
 strcpy(ex_fname, str);
 cur_count=cmd_count;
 cmds_open(ex_fname);
}

int start_loop_n(unsigned long counter)
{
 int ps_f;

 if (counter == 1) goto one_start;
 gotoxy(1, 11);
 textcolor(CYAN);
 printf("᪨ .  PrtScr  室...");
 textcolor(LIGHTGRAY);
 while (counter == 0 || counter > 1)   /*      */
 {
  start();
  if (pause) my_wait(pause);
  if (prtscr_flag) break;
  if (kbhit()) break;
  if (counter) counter--;
 }
 if (kbhit())
  bioskey();
 if (nwin == nmainwin)
  textcolor(WHITE);
 gotoxy(1, 11);
 printf("");
 textcolor(LIGHTGRAY);
 ps_f=prtscr_flag;
 prtscr_flag=0;
 one_start:
 start_1("");
 statistic_out("");
 if ((to_errors+channel_err+bad_starts) < err_level && !(ps_f && counter)) return 0;
 else return 1;
}

int start_1(char *str)                                  /*   */
{
 if (end_ctrl(str)) return 0;
 if (!avtomat)
 {
  gotoxy(1, 10);
  clreol();
 }
 out_base();
 out_ctrl_code();
 start();
 if (avtomat)
 {
  select_window(rtwin);
  out_at();
  out_inn();
  out_status_word();
  out_page();
  out_subadr();
  rt_out_sw();
  if (avt_out)
   rt_out_ram(dir, subadr);
  select_window(bcwin);
 }
 out_inn();
 bc_out_sw();
 bc_out_ram(base);
 if (avtomat) statistic_out("");
 if ((to_errors+channel_err+bad_starts) < 1) return 0;
 else return 1;
}

int start_loop(char *str)            /*   横 */
/* প : 0 - 室  襭, 
                     1 - 室  PrtScr   ERR_LEVEL */
{
 unsigned long counter;

 while (*str == '\t' || *str == ' ') str++;
 counter=0;
 if (*str != '\0')
 {                                       /* 横᪨   稪 */
  if (sscanf(str, "%U", &counter) != 1)
  {
   msg_out(inp_err);
   return 1;
  }
 }
 else counter = 0;
 return start_loop_n(counter);
}

int start()
/* প : 0 - 室  ⠩-, 1 - 室  뢠 */
{
 unsigned long p;

 int_num[Window[nwin].nTMK] = 0;
 bcstart(base, ctrl_code);
 p = biostime(0, 0L);  /*  뢠 2 (10) ⨪ */
 do
 {
  CheckTmkEvent(fGlobalWaitEvent);
//  CheckTmkProxy(NO_WAIT_PROXY);
  if (int_num[Window[nwin].nTMK] != 0) return 1;
 }
 while (biostime(0, 0L) - p < 10);
 bc_sw = 0;
 to_errors++;
 return 0;
}

void prtscr_brk()                /* ࠡ稪 뢠  PrtScr */
{
 prtscr_flag = 1;
}

void cmd_reset(char *str)                               /*  ஫ */
{
 if (end_ctrl(str)) return;
 switch (Window[nwin].nMode)
 {
 case BC_MODE:
  bcreset();
  bcdefbase(base);
  msg_out(bc_reset_ok);
  break;
 case RT_MODE:
  rtreset();
  wr_at(terminal_adr);
  rtdefpage(bram_page);
  rtdefsubaddr(dir, subadr);
  msg_out(rt_reset_ok);
  break;
 }
}


void msg_out(char *msg)                  /* 뢮 ப ᮮ饭 */
{
 gotoxy(1, Window[nwin].nDY);
 textcolor(CYAN);
 printf("%s.   ...", msg);
 while (!kbhit())
  WaitForMultipleObjects(nWaitEvents+1, ahWaitEvents, FALSE, 0);
 bioskey();
 if (nwin == nmainwin)
 {
  textcolor(WHITE);
  chH = '';
 }
 else
 {
  textcolor(LIGHTGRAY);
  chH = '';
 }
 gotoxy(1, Window[nwin].nDY);
 hor_line(Window[nwin].nDX-2);
 textcolor(LIGHTGRAY);
}

void rd_sw_loop(char *str)               /* ⥭ ᫮ ﭨ  横 */
{
 if (end_ctrl(str)) return;
 gotoxy(1, 10);
 textcolor(CYAN);
 printf("⥭ ॣ ﭨ.     室...");
 textcolor(LIGHTGRAY);
 while (kbhit() == 0)                   /*      */
  rt_sw = rtgetstate();
 bioskey();
 gotoxy(1, 10);
 clreol();
 rt_out_sw();
}

void wr_mr_loop(char *str)                     /* 横᪠    */
{
 if (end_ctrl(str)) return;
 gotoxy(1, 10);
 textcolor(CYAN);
 printf("  ॣ ०.     室...");
 textcolor(LIGHTGRAY);
 while (kbhit() == 0)                   /*      */
  rtunlock();
 fLock=0;
 bioskey();
 gotoxy(1, 10);
 clreol();
}

void set_flag(char *str)         /* ⠭ 䫠 */
{
 if (end_ctrl(str)) return;
 gotoxy(1, 10);
 textcolor(CYAN);
 printf(" 䫠.     室...");
 textcolor(LIGHTGRAY);
 while (!kbhit())                   /*      */
 {
  if (dir == RT_TRANSMIT)
   rtsetflag();
  else
   rtclrflag();
 }
 bioskey();
 gotoxy(1, 10);
 clreol();
}

void read_sw(char *str)                 /* ⥭ ॣ ﭨ */
{
 if (end_ctrl(str)) return;
 rt_sw = rtgetstate();
 rt_out_sw();
}

void check_int()         /* 㦥 宦 뢠  饭 */
{
// int cx, cy;
 int fRestore, savenwin;

 fRestore = 0;
 savenwin = nwin;
 CheckTmkEvent(NO_WAIT_EVENT);
 for (nwin = 0; nwin <= nMaxWin; nwin++)
 {
  if (Window[nwin].nMode == RT_MODE && int_num[Window[nwin].nTMK])
  {
   if (Window[nwin].fVisible)
   {
    if (!fRestore)
    {
     fRestore = 1;
//     cx=wherex(); cy=wherey();
    }
    fInt = 1;
    select_window(nwin);
    out_inn();
    rt_out_sw();
    if (!avtomat) msg_out("뢠");
    fInt = 0;
    int_num[Window[nwin].nTMK]=0;
   }
  }
 }
 nwin = savenwin;
 if (fRestore)
 {
  select_window(nwin);
  window(1, 1, 80, 25);
  gotoxy(1, 23);
 }
}

int in_key()                    /*  ᨬ  ஢મ 뢠 */
{
 int key;
 int cx, cy;

 if (enter_mode)
 {
  check_int();
  key=fgetc(cmd_file);          /* ⥭ ᨬ   䠩 */
  if (key == EOF || fSkipCmds)
  {
   fclose(cmd_file);
   if (Window[nwin].nMode == BC_MODE && cmd_count != 1 && --cur_count != 0 && !fSkipCmds)
   {
//    cx=wherex(); cy=wherey();  /* 横᪮ 믮 */
    select_window(nwin);
    gotoxy(59, 2);
    printf("%010lu", cur_count);
    window(1, 1, 80, 25);
    gotoxy(cx, cy);
    cmds_open(ex_fname);
    check_int();
    key=fgetc(cmd_file);
   }
   else
   {
    if (Window[nwin].nMode == BC_MODE)
    {
//     cx=wherex(); cy=wherey(); /* 襭 横 */
     select_window(nwin);
     gotoxy(59, 2);
     printf("%010lu", cmd_count);
     window(1, 1, 80, 25);
     gotoxy(1, 23);
    }
    enter_mode=0;
    fSkipCmds=0;
    while (kbhit() == 0)
    {
     WaitForMultipleObjects(nWaitEvents+1, ahWaitEvents, FALSE, 0);
     check_int();
    }
    key=bioskey();
   }
  }
 }
 else
 {
  while (kbhit() == 0)
  {
   WaitForMultipleObjects(nWaitEvents + 1, ahWaitEvents, FALSE, INFINITE);
   check_int();
  }
  key=bioskey();
 }
 return key;
}

void in_cmd(char *str)
/*   ப  str, ᥫ஢ ࠢ  㭪樮 */
{
 unsigned short key;                       /*  ਭ  , ... */
 int fInCmd;
// char ch;

 str_ptr = 0;
 fInCmd = 0;
 do
 {
  if (!fInCmd)
  {
   window(1, 1, 80, 25);
   gotoxy(1, 23);
   clreol();
   printf(": ");
   cmd_str[str_ptr]='\0';
   printf(cmd_str);
  }
  fInCmd = 0;
  key = in_key();
  if ((key & 0x00FF) && key != GPLUSW)
  {
   if ((key&=0x00FF) < 0x20 && key != CR && key != LF)
   {
    make_ctrl(key);
    continue;
   }
   key=str[str_ptr++]=toupper(key&=0x00FF);
   putchar(key);
   fInCmd = 1;
  }
  else
  {
   window(Window[nwin].nX + 1, Window[nwin].nY, 
           Window[nwin].nX + Window[nwin].nDX - 2, 
           Window[nwin].nY + Window[nwin].nDY - 1);
   make_func(key);
   continue;
  }
 }
 while (key != CR && key != LF);
 str[--str_ptr]='\0';
}

void make_ctrl(int key)
/* ࠡ⪠ ࠢ , key - ࠢ騩 . */
{
 switch (key)
 {
 case BACKSPACE:
  if (str_ptr != 0)     /*  */
  {
   --str_ptr;
   printf("\x08 \x08");
  }
  break;
 case ESCAPE:       /* ⬥ ᥩ ப */
  str_ptr=0;
  break;
 case TAB:
  str_ptr=0;
  nmainwin = !nmainwin;
  int_num[Window[0].nTMK] = 0;
  int_num[Window[1].nTMK] = 0;
  select_window(nmainwin);
  all_screen();
  break;
 }
}

void make_func(unsigned short key)
/*
ࠡ⪠ 㭪樮 , F1..F10
key - ७  ASCII
*/
{
 switch (key)
 {
 case UP:   /*   ।饩  */
            strcpy(cmd_str, old_cmd);
            str_ptr=strlen(cmd_str);
            break;
 case F01:  switch (Window[nwin].nMode)
            {
            case BC_MODE:
             bc_help("");
             break;
            case RT_MODE:
             rt_help("");
             break;
            }
            break;
 case F02:  buf_edit("");
            break;
 case F03:  int_num[Window[nwin].nTMK] = 0;
            switch (Window[nwin].nMode)
            {
            case RT_MODE:
             if (!set_mode(BC_MODE))
             {
              base = 0;
              bcdefbase(0);
             }
             all_screen();
             break;
            case BC_MODE:
             if (!set_mode(RT_MODE))
             {
              cram_page = bram_page = 0;
              rtdefpage(0);
              dir = RT_RECEIVE;
              subadr = 1;
              rtdefsubaddr(dir, subadr);
              }
             all_screen();
             break;
            }
            break;
 case F04:
            str_ptr=0;
            nmainwin = !nmainwin;
            int_num[Window[0].nTMK] = 0;
            int_num[Window[1].nTMK] = 0;
            select_window(nmainwin);
            all_screen();
            break;
 case F05:
            break;
 case F06:  switch (Window[nwin].nMode)
            {
            case BC_MODE:
             start_1("");
             break;
            case RT_MODE:
             read_sw("");
             break;
            }
            break;
 case F07:  switch (Window[nwin].nMode)
            {
            case BC_MODE:
             start_loop("");
             break;
            case RT_MODE:
             rtlock(dir, subadr);
             fLock=1;
             break;
            }
            break;
 case F08:  cmd_reset("");
            break;
 case F09:  fields_chg("");
            break;
 case F10:  make_quit();
            break;
 case GPLUS:if (Window[nwin].nMode == RT_MODE)
            {
             dir = (dir == RT_TRANSMIT) ? RT_RECEIVE : RT_TRANSMIT;
             out_subadr();
             rt_out_ram(dir, subadr);
            }
            break;
 case PGUP: switch (Window[nwin].nMode)
            {
            case BC_MODE:
             if (base > 0)
             {
              base--;
              out_base();
              bc_out_ram(base);
             }
             break;
            case RT_MODE:
             if (subadr > 0)
             {
              subadr--;
              out_subadr();
              rt_out_ram(dir, subadr);
             }
            }
            break;
 case PGDN: switch (Window[nwin].nMode)
            {
            case BC_MODE:
             if (base < bcgetmaxbase())
             {
              base++;
              out_base();
              bc_out_ram(base);
             }
             break;
            case RT_MODE:
             if (subadr < 31)
             {
              subadr++;
              out_subadr();
              rt_out_ram(dir, subadr);
             }
            }
            break;
 }
}
